SystemOrganization addCategory: #'Jihachol-Morphic'!
SystemOrganization addCategory: #'Jihachol-RealData'!
SystemOrganization addCategory: #'Jihachol-Helpers'!
SystemOrganization addCategory: #Jihachol!

Morph subclass: #JhcStationMorph
	instanceVariableNames: 'station'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol-Morphic'!

!JhcStationMorph methodsFor: 'as yet unclassified' stamp: 'hjo 10/31/2009 17:18'!
drawOn: aCanvas

	super drawOn: aCanvas.
	self hasModel
		ifTrue: [aCanvas drawString: station name in: self bounds font: nil color: Color white].! !

!JhcStationMorph methodsFor: 'as yet unclassified' stamp: 'hjo 10/31/2009 17:18'!
hasModel

	^station isNil not! !

!JhcStationMorph methodsFor: 'as yet unclassified' stamp: 'hjo 10/31/2009 17:34'!
setRandomStation

	self station: (JhcSubway new buildAllLines; stations) atRandom.
	self flash! !

!JhcStationMorph methodsFor: 'as yet unclassified' stamp: 'hjo 10/31/2009 13:56'!
station: aJhcStation

	station := aJhcStation.
	self color: aJhcStation line lineColor! !

TestCase subclass: #JhcGraphicRepresentationTest
	instanceVariableNames: 'subway'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcGraphicRepresentationTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/31/2009 18:27'!
setUp

	| line station |
	subway := JhcSubway basicNew.
	line := JhcLine new.
	station := line addStationNamed: 'A'.
	station screenPosition: 2@3.
	station := line addStationNamed: 'B'.
	station screenPosition: 12@3.
	station := line addStationNamed: 'C'.
	station screenPosition: 25@25.
	station := line addStationNamed: 'D'.
	station screenPosition: 120@300.
	station := line addStationNamed: 'E'.
	station screenPosition: 120@300.
	
	subway lines: (Array with: line)! !

!JhcGraphicRepresentationTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/31/2009 18:26'!
testNearTouchRadius

	subway nearTouchRadius: 30.
	self assert: (subway nearStationAt: 20@30) size equals: 2.
	
	subway nearTouchRadius: 10.
	self assert: (subway nearStationAt: 20@30) size equals: 1! !

TestCase subclass: #JhcLineJooyungHanTest
	instanceVariableNames: 'line scrum tdd refactoring pp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLineJooyungHanTest commentStamp: 'hjo 10/13/2009 10:48' prior: 0!
hjo: I think this class can be merged to other testing class. Too simple to stay alone.!

!JhcLineJooyungHanTest methodsFor: 'running' stamp: 'hjo 11/9/2009 01:50'!
setUp

	| input |
	input := 'jh01	Refactoring	2
jh02	TDD	2
jh03	PP	2
jh04	Scrum	2'.
	line := JhcLine loadData: input for: 'Jooyung Han'.
	
	scrum := line stationAtName: 'Scrum'.
	tdd := line stationAtName: 'TDD'.
	refactoring := line stationAtName: 'Refactoring'.
	pp := line stationAtName: 'PP'.
	! !

!JhcLineJooyungHanTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 00:48'!
testCircularLine
	self assert: (refactoring neighbors includes: tdd).
	self assert: (tdd neighbors includes: pp).
	self assert: (pp neighbors includes: scrum).
	self assert: (scrum neighbors includes: refactoring).! !

!JhcLineJooyungHanTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/20/2009 18:52'!
testStationAtNameFail

	self should: [line stationAtName: 'zzz'] raise: AssertionFailure! !

!JhcLineJooyungHanTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 00:26'!
testStationCount
	self assert:4 equals: line stations size! !

!JhcLineJooyungHanTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 01:04'!
testTimeSpan
	|cost|
	cost := JhcStation defaultCost.
	self assert: 0 equals: (refactoring timespanMinutesTo: refactoring).
	self assert: cost equals: (refactoring timespanMinutesTo: tdd).
	self assert: cost*2 equals: (refactoring timespanMinutesTo: pp).! !

TestCase subclass: #JhcLineRealDataTest
	instanceVariableNames: 'line'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol-RealData'!

JhcLineRealDataTest subclass: #JhcBundangLineTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcBundangLineTest methodsFor: 'running' stamp: 'hjo 9/28/2009 13:12'!
setUp

	super setUp.
	line := JhcLine bundang.
	
	

	! !

!JhcBundangLineTest methodsFor: 'station' stamp: 'hjo 10/31/2009 16:35'!
testDogok

	self assertStation: (line stations at: 3) lineName: 'Bundang' id: 'K217' name: 'Dogok' secondName: nil
! !

!JhcBundangLineTest methodsFor: 'station' stamp: 'hjo 10/31/2009 16:36'!
testGaepoDong

	self assertStation: (line stations at: 5) lineName: 'Bundang' id: 'K219' name: 'Gaepo-dong' secondName: nil
! !

!JhcBundangLineTest methodsFor: 'station' stamp: 'hjo 10/31/2009 16:36'!
testGuryong

	self assertStation: (line stations at: 4) lineName: 'Bundang' id: 'K218' name: 'Guryong' secondName: nil
! !

!JhcBundangLineTest methodsFor: 'station' stamp: 'hjo 10/31/2009 16:37'!
testHanti

	self assertStation: (line stations at: 2) lineName: 'Bundang' id: 'K216' name: 'Hanti' secondName: nil! !

!JhcBundangLineTest methodsFor: 'station' stamp: 'hjo 10/31/2009 16:37'!
testOri

	self assertStation: (line stations at: 18) lineName: 'Bundang' id: 'K232' name: 'Ori' secondName: nil! !

!JhcBundangLineTest methodsFor: 'station' stamp: 'hjo 10/31/2009 16:38'!
testSeolleung

	self assertStation: (line stations at: 1) lineName: 'Bundang' id: 'K215' name: 'Seolleung' secondName: nil! !

!JhcBundangLineTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:38'!
testTimeSpanFromBojeongToGaepoDong

	self assert: (self timeFrom: 'Gaepo-dong' to: 'Bojeong') equals: 40! !

!JhcBundangLineTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:39'!
testTimeSpanFromDogokToSeolleung

	self assert: (self timeFrom: 'Seolleung' to: 'Dogok') equals: 4! !

!JhcBundangLineTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:40'!
testTimeSpanFromSuseoToKyungwonUniv

	self assert: (self timeFrom: 'Suseo' to: 'Kyungwon Univ.') equals: 7! !

JhcLineRealDataTest subclass: #JhcLine1Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol-RealData'!

!JhcLine1Test methodsFor: 'running' stamp: 'hjo 10/13/2009 13:30'!
setUp

	super setUp.
	line := JhcLine line1! !

!JhcLine1Test methodsFor: 'station' stamp: 'hjo 10/31/2009 16:41'!
testCheongnyangni

	self assertStationAtName: 'Cheongnyangni' id: '124' lineName: '1' secondName: nil ! !

!JhcLine1Test methodsFor: 'station' stamp: 'hjo 10/31/2009 16:48'!
testDongdaemun

	self assertStationAtName: 'Dongdaemun' id: '128' lineName: '1' secondName: nil ! !

!JhcLine1Test methodsFor: 'routing' stamp: 'hjo 10/13/2009 13:40'!
testFromDongdaemunToJegidong

	self assert: (self timeFrom: 'Dongdaemun' to: 'Jegi-dong') equals: 5! !

!JhcLine1Test methodsFor: 'routing' stamp: 'hjo 10/13/2009 13:36'!
testFromSeoulStationToJonggak

	self assert: (self timeFrom: 'Seoul Station' to: 'Jonggak') equals: 5! !

!JhcLine1Test methodsFor: 'routing' stamp: 'hjo 10/13/2009 13:39'!
testFromSeoulStationToSeoulStation

	self assert: (self timeFrom: 'Seoul Station' to: 'Seoul Station') equals: 0! !

!JhcLine1Test methodsFor: 'as yet unclassified' stamp: 'hjo 10/13/2009 13:50'!
testLineColor

	self assert: line lineColor equals: (Color r: 13/255 g: 54/255 b: 146/255)! !

!JhcLine1Test methodsFor: 'station' stamp: 'hjo 10/31/2009 16:48'!
testSeoulStation

	self assertStationAtName: 'Seoul Station' id: '133' lineName: '1' secondName: nil ! !

JhcLineRealDataTest subclass: #JhcLine2RingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol-RealData'!

!JhcLine2RingTest methodsFor: 'running' stamp: 'hjo 10/10/2009 08:44'!
setUp

	super setUp.
	line := JhcLine line2Ring! !

!JhcLine2RingTest methodsFor: 'stations' stamp: 'hjo 10/31/2009 14:14'!
testAhyeon

	self assertStation: (line stations at: 42) lineName: '2' id: '242' name: 'Ahyeon' secondName: nil! !

!JhcLine2RingTest methodsFor: 'stations' stamp: 'hjo 10/31/2009 14:15'!
testChungjeongno
	
	self assertStation: (line stations at: 43) lineName: '2' id: '243' name: 'Chungjeongno' secondName:  'Kyonggi Univ.'! !

!JhcLine2RingTest methodsFor: 'stations' stamp: 'hjo 10/31/2009 14:16'!
testCityHall
	
	self assertStation: (line stations at: 1) lineName: '2' id: '201' name: 'City Hall' secondName: nil! !

!JhcLine2RingTest methodsFor: 'stations' stamp: 'hjo 10/31/2009 14:17'!
testEuljiroSamGa

	self assertStation: (line stations at: 3) lineName: '2' id: '203' name: 'Euljiro 3(sam)-ga' secondName: nil! !

!JhcLine2RingTest methodsFor: 'stations' stamp: 'hjo 10/31/2009 14:18'!
testEuljiroilga

	self assertStation: (line stations at: 2) lineName: '2' id: '202' name: 'Euljiro 1(il)-ga' secondName: nil! !

!JhcLine2RingTest methodsFor: 'stations' stamp: 'hjo 10/31/2009 14:18'!
testEwhaWomansUniv

	self assertStation: (line stations at: 41) lineName: '2' id: '241' name: 'Ewha Womans Univ.' secondName: nil! !

!JhcLine2RingTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:41'!
testFromCityHallToAhyeon

	self assert: (self timeFrom: 'City Hall' to: 'Ahyeon') equals: 4! !

!JhcLine2RingTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:44'!
testFromCityHallToDongdaemun

	self assert: (self timeFrom: 'City Hall' to: 'Dongdaemun Stadium') equals: 7! !

!JhcLine2RingTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:44'!
testFromCityHallToSeongnae

	self assert: (self timeFrom: 'City Hall' to: 'Seongnae') equals: 28! !

!JhcLine2RingTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:45'!
testFromSeongnaeToSindaebang

	self assert: (self timeFrom: 'Sindaebang' to: 'Seongnae') equals: 34! !

!JhcLine2RingTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:45'!
testFromSindaebangToCityHall

	self assert: (self timeFrom: 'Sindaebang' to: 'City Hall') equals: 29! !

!JhcLine2RingTest methodsFor: 'stations' stamp: 'hjo 10/31/2009 14:19'!
testSeongsu

	self assertStation: (line stations at: 11) lineName: '2' id: '211' name: 'Seongsu' secondName: nil! !

!JhcLine2RingTest methodsFor: 'stations' stamp: 'hjo 10/31/2009 14:20'!
testSindorim

	self assertStation: (line stations at: 34) lineName: '2' id: '234' name: 'Sindorim' secondName: nil! !

JhcLineRealDataTest subclass: #JhcLine2SeongsuBranchTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol-RealData'!

!JhcLine2SeongsuBranchTest methodsFor: 'running' stamp: 'hjo 10/8/2009 19:53'!
setUp

	super setUp.
	line := JhcLine line2SeongsuBranch! !

!JhcLine2SeongsuBranchTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:47'!
testFromSeongsuToSinseolDong

	self assert: (self timeFrom: 'Seongsu' to: 'Sinseol-dong') equals: 9! !

!JhcLine2SeongsuBranchTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:48'!
testFromSinseolDongToYongdap

	self assert: (self timeFrom: 'Sinseol-dong' to: 'Yongdap') equals: 6! !

!JhcLine2SeongsuBranchTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:49'!
testFromYongdapToSindap

	self assert: (self timeFrom: 'Yongdap' to: 'Sindap') equals: 2! !

!JhcLine2SeongsuBranchTest methodsFor: 'station' stamp: 'hjo 10/31/2009 14:21'!
testSeongsu

	self assertStation: (line stations at: 1) lineName: '2-seongsu-branch' id: '211' name: 'Seongsu' secondName: nil! !

!JhcLine2SeongsuBranchTest methodsFor: 'station' stamp: 'hjo 10/31/2009 14:23'!
testSindap

	self assertStation: (line stations at: 3) lineName: '2-seongsu-branch' id: '211-2' name: 'Sindap' secondName: nil! !

!JhcLine2SeongsuBranchTest methodsFor: 'station' stamp: 'hjo 10/31/2009 14:33'!
testSinseoldong

	self assertStation: (line stations at: 5) lineName: '2-seongsu-branch' id: '211-4' name: 'Sinseol-dong' secondName: nil! !

!JhcLine2SeongsuBranchTest methodsFor: 'station' stamp: 'hjo 10/31/2009 14:38'!
testYongdap

	self assertStation: (line stations at: 2) lineName: '2-seongsu-branch' id: '211-1' name: 'Yongdap' secondName: nil! !

!JhcLine2SeongsuBranchTest methodsFor: 'station' stamp: 'hjo 10/31/2009 14:39'!
testYongdu

	self assertStation: (line stations at: 4) lineName: '2-seongsu-branch' id: '211-3' name: 'Yongdu' secondName: 'Dongdaemun-gu Office'
! !

JhcLineRealDataTest subclass: #JhcLine2SinjeongBranchTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol-RealData'!

!JhcLine2SinjeongBranchTest methodsFor: 'running' stamp: 'hjo 10/9/2009 22:18'!
setUp

	super setUp.
	line := JhcLine line2SinjeongBranch! !

!JhcLine2SinjeongBranchTest methodsFor: 'station' stamp: 'hjo 10/31/2009 14:40'!
testDorimcheon

	self assertStation: (line stations at: 2) lineName: '2-sinjeong-branch' id: '234-1' name: 'Dorimcheon' secondName: nil
! !

!JhcLine2SinjeongBranchTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:53'!
testFromDorimcheonToSinjeongnegeori

	self assert: (self timeFrom: 'Dorimcheon' to: 'Sinjeongnegeori') equals: 7! !

!JhcLine2SinjeongBranchTest methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:52'!
testFromSindorimToKkachisan

	self assert: (self timeFrom: 'Sindorim' to: 'Kkachisan') equals:  12! !

!JhcLine2SinjeongBranchTest methodsFor: 'station' stamp: 'hjo 10/31/2009 14:41'!
testKkachisan

	self assertStation: (line stations at: 5) lineName: '2-sinjeong-branch' id: '234-4' name: 'Kkachisan' secondName: nil
! !

!JhcLine2SinjeongBranchTest methodsFor: 'station' stamp: 'hjo 10/31/2009 14:41'!
testSindorim

	self assertStation: (line stations at: 1) lineName: '2-sinjeong-branch' id: '234' name: 'Sindorim' secondName: nil
! !

!JhcLine2SinjeongBranchTest methodsFor: 'station' stamp: 'hjo 10/31/2009 14:46'!
testSinjeongnegeori

	self assertStation: (line stations at: 4) lineName: '2-sinjeong-branch' id: '234-3' name: 'Sinjeongnegeori' secondName: nil
! !

!JhcLine2SinjeongBranchTest methodsFor: 'station' stamp: 'hjo 10/31/2009 14:47'!
testYangcheonGuOffice

	self assertStation: (line stations at: 3) lineName: '2-sinjeong-branch' id: '234-2' name: 'Yangcheon-gu Office' secondName: nil
! !

JhcLineRealDataTest subclass: #JhcLine2Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol-RealData'!

!JhcLine2Test methodsFor: 'running' stamp: 'jhan 10/13/2009 09:54'!
setUp

	super setUp.
	line := JhcLine line2! !

!JhcLine2Test methodsFor: 'as yet unclassified' stamp: 'hjo 10/12/2009 15:09'!
testFromMullaeToDorimcheon

	self assert: (self timeFrom: 'Mullae' to: 'Dorimcheon') equals: 18! !

!JhcLine2Test methodsFor: 'as yet unclassified' stamp: 'jhan 10/13/2009 09:55'!
testFromSeongsuToSomewhere

	self assert: (self timeFrom: 'Seongsu' to: 'Ttukseom') equals: 1.
	self assert: (self timeFrom: 'Seongsu' to: 'Sinseol-dong') equals: 9.
	self assert: (self timeFrom: 'Ttukseom' to: 'Seongsu') equals: 1.
	self assert: (self timeFrom: 'Sinseol-dong' to: 'Seongsu') equals: 9! !

!JhcLine2Test methodsFor: 'as yet unclassified' stamp: 'jhan 10/12/2009 16:28'!
testFromWangsimniToSindap
	"Wangsimni 2 Hanyang Univ. 3 Ttukseom 1 Seongsu 11 Seongsu 3 Yongdap 2 Sindap => 22 minutes"
	self assert: (self timeFrom: 'Wangsimni' to: 'Sindap') equals: 22! !

!JhcLine2Test methodsFor: 'as yet unclassified' stamp: 'hjo 10/13/2009 14:27'!
testLineColor

	"RGB 51,162,61"
	self assert: line lineColor equals: (Color r: 51/255 g: 162/255 b: 61/255)! !

!JhcLine2Test methodsFor: 'as yet unclassified' stamp: 'hjo 10/31/2009 14:48'!
testSeongsuHasTwoLines
	| seongsu |
	seongsu := line stationAtName: 'Seongsu'.
	self assert: seongsu lineNames equalsArray: #('2' '2-seongsu-branch')! !

!JhcLine2Test methodsFor: 'as yet unclassified' stamp: 'hjo 10/10/2009 09:02'!
testStationsOfEachPartExist

	self shouldnt: [line stations detect: [:each| each name = 'Wangsimni' ]] raise: Error.
	self shouldnt: [line stations detect: [:each| each name = 'Yongdap' ]] raise: Error.
	self shouldnt: [line stations detect: [:each| each name = 'Dorimcheon' ]] raise: Error	! !

!JhcLine2Test methodsFor: 'as yet unclassified' stamp: 'hjo 10/31/2009 14:51'!
testTtukseomHasOneLine
	| station |
	station := line stationAtName: 'Ttukseom'.
	self assert: station lineNames equalsArray: #('2')! !

JhcLineRealDataTest subclass: #JhcLine3Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol-RealData'!

!JhcLine3Test methodsFor: 'running' stamp: 'jhan 10/11/2009 23:12'!
setUp
	line := JhcLine line3! !

!JhcLine3Test methodsFor: 'station' stamp: 'hjo 10/31/2009 14:53'!
testExpressBusTerminal

	self assertStationAtName: 'Express Bus Terminal' id: '339' lineName: '3' secondName: nil! !

!JhcLine3Test methodsFor: 'routing' stamp: 'hjo 10/20/2009 17:31'!
testFromDaehwaToJeongbalsan
	self assert: (self timeFrom: 'Daehwa' to: 'Jeongbalsan') equals: 6! !

!JhcLine3Test methodsFor: 'routing' stamp: 'hjo 10/20/2009 17:31'!
testFromDaehwaToMadu

	self assert: (self timeFrom: 'Daehwa' to: 'Madu') equals: 8! !

!JhcLine3Test methodsFor: 'routing' stamp: 'hjo 10/20/2009 17:32'!
testFromDaehwaToSuseo
	self assert: (self timeFrom: 'Daehwa' to: 'Suseo') equals: 89! !

!JhcLine3Test methodsFor: 'station' stamp: 'hjo 10/31/2009 14:57'!
testGyeongbokgung

	self assertStationAtName: 'Gyeongbokgung' id: '327' lineName: '3' secondName: 'Central Government Complex'! !

!JhcLine3Test methodsFor: 'station' stamp: 'hjo 10/31/2009 14:58'!
testJichuk

	self assertStationAtName: 'Jichuk' id: '319' lineName: '3' secondName:  nil! !

!JhcLine3Test methodsFor: 'etc' stamp: 'hjo 10/13/2009 14:28'!
testLineColor

	"RGB 254,91,16"
	self assert: line lineColor equals: (Color r: 254/255 g: 91/255 b: 16/255)! !

!JhcLine3Test methodsFor: 'etc' stamp: 'hjo 10/31/2009 14:07'!
testLineId
	self assert: ('3' = line lineName)! !

!JhcLine3Test methodsFor: 'station' stamp: 'hjo 10/31/2009 15:01'!
testSuseo

	self assertStationAtName: 'Suseo' id: '349' lineName: '3' secondName: nil! !

JhcLineRealDataTest subclass: #JhcLine4Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol-RealData'!

!JhcLine4Test methodsFor: 'running' stamp: 'hjo 10/13/2009 14:34'!
setUp

	super setUp.
	line := JhcLine line4! !

!JhcLine4Test methodsFor: 'stations' stamp: 'hjo 10/31/2009 15:01'!
testDongjak

	self assertStationAtName: 'Dongjak' id: '431' lineName: '4' secondName:   'Seoul National Cemetery'! !

!JhcLine4Test methodsFor: 'routing' stamp: 'hjo 10/20/2009 19:18'!
testFromDongjakToSadang

	self assert: (self timeFrom: 'Dongjak' to: 'Sadang' ) equals: 5! !

!JhcLine4Test methodsFor: 'routing' stamp: 'hjo 10/20/2009 19:17'!
testFromSuyuToHyehwa

	self assert: (self timeFrom: 'Suyu' to: 'Hyehwa' ) equals: 13! !

!JhcLine4Test methodsFor: 'stations' stamp: 'hjo 10/31/2009 15:02'!
testHansungUniv

	self assertStationAtName: 'Hansung Univ.' id: '419' lineName: '4' secondName:  'Samseongyo'! !

!JhcLine4Test methodsFor: 'stations' stamp: 'hjo 10/31/2009 15:03'!
testHoehyeon

	self assertStationAtName: 'Hoehyeon' id: '425' lineName: '4' secondName: 'Namdaemun Market' ! !

!JhcLine4Test methodsFor: 'stations' stamp: 'hjo 10/31/2009 15:04'!
testIsu

	self assertStationAtName: 'Isu' id: '432' lineName: '4' secondName:  'Chongshin Univ.'! !

!JhcLine4Test methodsFor: 'stations' stamp: 'hjo 10/31/2009 15:05'!
testJeongwang

	self assertStationAtName: 'Jeongwang' id: '455' lineName: '4' secondName:  'Korea Polytechnic Univ.'! !

!JhcLine4Test methodsFor: 'etc' stamp: 'hjo 10/13/2009 14:35'!
testLineColor

	self assert: line lineColor equals: (Color r:50/255 g:161/255 b: 200/255) ! !

!JhcLine4Test methodsFor: 'stations' stamp: 'hjo 10/31/2009 15:08'!
testSeoulGrandPark

	self assertStationAtName: 'Seoul Grand Park' id: '437' lineName: '4' secondName: 'Seoul Land'! !

!JhcLine4Test methodsFor: 'stations' stamp: 'hjo 10/31/2009 15:09'!
testSookmyungWomensUniv

	self assertStationAtName: 'Sookmyung Women''s Univ.' id: '427' lineName: '4' secondName: 'Garwol'! !

!JhcLine4Test methodsFor: 'stations' stamp: 'hjo 10/31/2009 15:20'!
testSungshinWomansUniv

	self assertStationAtName: 'Sungshin Woman''s Univ.' id: '418' lineName: '4' secondName: 'Donam'! !

JhcLineRealDataTest subclass: #JhcLine5MacheonBranchTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol-RealData'!

!JhcLine5MacheonBranchTest methodsFor: 'running' stamp: 'hjo 10/21/2009 15:14'!
setUp

	super setUp.
	line := JhcLine line5MacheonBranch! !

!JhcLine5MacheonBranchTest methodsFor: 'stations' stamp: 'hjo 10/31/2009 15:20'!
testBanghwa

	self assertStationAtName: 'Banghwa' id: '510' lineName: '5-macheon' secondName: nil! !

!JhcLine5MacheonBranchTest methodsFor: 'routing' stamp: 'hjo 10/21/2009 18:58'!
testFromAchasanToBangi

	self assert: (self timeFrom: 'Achasan' to: 'Bangi') equals: 13! !

!JhcLine5MacheonBranchTest methodsFor: 'stations' stamp: 'hjo 10/31/2009 15:21'!
testGaehwasan

	self assertStationAtName: 'Gaehwasan' id: '511' lineName: '5-macheon' secondName: nil! !

!JhcLine5MacheonBranchTest methodsFor: 'stations' stamp: 'hjo 10/31/2009 15:21'!
testGangdong

	self assertStationAtName: 'Gangdong' id: '548' lineName: '5-macheon' secondName: nil! !

!JhcLine5MacheonBranchTest methodsFor: 'stations' stamp: 'hjo 10/31/2009 15:22'!
testJongno3ga

	self assertStationAtName: 'Jongno 3(sam)-ga' id: '534' lineName: '5-macheon' secondName: 'Tapgol ParkInsa-dong'! !

!JhcLine5MacheonBranchTest methodsFor: 'stations' stamp: 'hjo 10/31/2009 15:26'!
testMacheon

	self assertStationAtName: 'Macheon' id: 'P555' lineName: '5-macheon' secondName: nil ! !

!JhcLine5MacheonBranchTest methodsFor: 'stations' stamp: 'hjo 10/31/2009 15:27'!
testOlympicPark

	self assertStationAtName: 'Olympic Park' id: 'P550' lineName: '5-macheon' secondName: 'Korean National Univ. of Physical Education'! !

!JhcLine5MacheonBranchTest methodsFor: 'stations' stamp: 'hjo 10/31/2009 15:27'!
testSinjeong

	self assertStationAtName: 'Sinjeong' id: '519' lineName: '5-macheon' secondName: 'Eunhaengjeong' 
! !

JhcLineRealDataTest subclass: #JhcLine5SangilDongBranchTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol-RealData'!

!JhcLine5SangilDongBranchTest methodsFor: 'running' stamp: 'hjo 10/22/2009 14:00'!
setUp

	super setUp.
	line := JhcLine line5SangilDongBranch! !

!JhcLine5SangilDongBranchTest methodsFor: 'stations' stamp: 'hjo 10/31/2009 15:28'!
testBanghwa

	self assertStationAtName: 'Banghwa' id: '510' lineName: '5-Sang-il-dong' secondName: nil 
! !

!JhcLine5SangilDongBranchTest methodsFor: 'stations' stamp: 'hjo 10/31/2009 15:28'!
testGunja

	self assertStationAtName: 'Gunja' id: '544' lineName: '5-Sang-il-dong' secondName: nil ! !

!JhcLine5SangilDongBranchTest methodsFor: 'stations' stamp: 'hjo 10/31/2009 15:29'!
testKkachisan

	self assertStationAtName: 'Kkachisan' id: '518' lineName: '5-Sang-il-dong' secondName: nil ! !

!JhcLine5SangilDongBranchTest methodsFor: 'stations' stamp: 'hjo 10/31/2009 15:29'!
testSangilDong

	self assertStationAtName: 'Sangil-dong' id: '553' lineName: '5-Sang-il-dong' secondName: nil ! !

!JhcLine5SangilDongBranchTest methodsFor: 'stations' stamp: 'hjo 10/31/2009 15:30'!
testSeodaemun

	self assertStationAtName: 'Seodaemun' id: '532' lineName: '5-Sang-il-dong' secondName: nil ! !

JhcLineRealDataTest subclass: #JhcLine5Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol-RealData'!

!JhcLine5Test methodsFor: 'running' stamp: 'hjo 10/13/2009 14:37'!
setUp

	super setUp.
	line := JhcLine line5! !

!JhcLine5Test methodsFor: 'stations' stamp: 'hjo 11/10/2009 13:54'!
testBanghwa

	self assertStationAtName: 'Banghwa' id: '510' lineNames: #('5-macheon' '5-Sang-il-dong') secondName: nil! !

!JhcLine5Test methodsFor: 'stations' stamp: 'hjo 11/10/2009 14:04'!
testFromAchasanToBangi

	self assert: (self timeFrom: 'Achasan' to: 'Bangi') equals: 13! !

!JhcLine5Test methodsFor: 'etc' stamp: 'hjo 10/13/2009 14:37'!
testLineColor

	self assert: line lineColor equals: (Color r:139/255 g:80/255 b:164/255)! !

!JhcLine5Test methodsFor: 'stations' stamp: 'hjo 11/10/2009 13:54'!
testMacheon

	self assertStationAtName: 'Macheon' id: 'P555' lineName: '5-macheon' secondName: nil ! !

!JhcLine5Test methodsFor: 'stations' stamp: 'hjo 11/10/2009 13:57'!
testSangilDong

	self assertStationAtName: 'Sangil-dong' id: '553' lineName: '5-Sang-il-dong' secondName: nil! !

JhcLineRealDataTest subclass: #JhcLine6Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol-RealData'!

!JhcLine6Test methodsFor: 'running' stamp: 'hjo 9/28/2009 18:59'!
setUp

	super setUp.
	line := JhcLine line6! !

!JhcLine6Test methodsFor: 'station' stamp: 'hjo 10/31/2009 15:31'!
testBonghwasan

	self assertStation: (line stations at: 38) lineName: '6' id: '647' name: 'Bonghwasan' secondName: nil
! !

!JhcLine6Test methodsFor: 'station' stamp: 'hjo 10/31/2009 15:32'!
testEungam

	self assertStation: (line stations at: 1) lineName: '6' id: '610' name: 'Eungam' secondName: nil! !

!JhcLine6Test methodsFor: 'station' stamp: 'hjo 10/31/2009 15:32'!
testGusan

	self assertStation: (line stations at: 6) lineName: '6' id: '615' name: 'Gusan' secondName: nil! !

!JhcLine6Test methodsFor: 'as yet unclassified' stamp: 'hjo 10/13/2009 14:40'!
testLineColor

	"RGB 197,92,29"
	self assert: line lineColor equals: (Color r:197/255 g:92/255 b:29/255 )! !

!JhcLine6Test methodsFor: 'station' stamp: 'hjo 10/31/2009 15:32'!
testMangwon

	self assertStation: (line stations at: 12) lineName: '6' id: '621' name: 'Mangwon' secondName: nil! !

!JhcLine6Test methodsFor: 'station' stamp: 'hjo 10/31/2009 15:33'!
testSaejeol

	self assertStation: (line stations at: 7) lineName: '6' id: '616' name: 'Saejeol' secondName: 'Sinsa'! !

!JhcLine6Test methodsFor: 'station' stamp: 'hjo 10/23/2009 14:53'!
testStraightLineStations

	self assert: (line stations at: 1) name equals: 'Eungam'.
	self assert: (line stations at: 7) name equals: 'Saejeol'.
	self assert: (line stations at: 8) name equals: 'Jeungsan'.
	self assert: (line stations at: 9) name equals: 'Digital Media City'.
	"..."
	self assert: (line stations at: 36) name equals: 'Taereung'.
	self assert: (line stations at: 37) name equals: 'Hwarangdae'.
	self assert: (line stations at: 38) name equals: 'Bonghwasan'.! !

!JhcLine6Test methodsFor: 'routing' stamp: 'hjo 10/19/2009 16:44'!
testTimeSpanFromEungamToBonghwasan

	self assert: (self timeFrom: 'Eungam' to: 'Bonghwasan') equals: 58! !

!JhcLine6Test methodsFor: 'routing' stamp: 'hjo 11/12/2009 16:10'!
testTimeSpanFromGusanToYeokchon
	" if transfer takes 2min, gusan to yeokchon will take 6 ( gusan 2 eongam 4 eongam 2 yeokchon ) "
	self assert: (self timeFrom: 'Gusan' to: 'Yeokchon') equals: 8! !

!JhcLine6Test methodsFor: 'routing' stamp: 'hjo 10/23/2009 17:38'!
testTimeSpanFromYeokchonToGusan

	self assert: (self timeFrom: 'Yeokchon' to: 'Gusan') equals: 8! !

!JhcLine6Test methodsFor: 'routing' stamp: 'hjo 11/12/2009 16:11'!
testTimeSpanFromYeokchonToSaejeol

	self assert: (self timeFrom: 'Yeokchon' to: 'Saejeol') equals:  16! !

!JhcLine6Test methodsFor: 'station' stamp: 'hjo 10/31/2009 15:34'!
testYeokchon

	self assertStation: (line stations at: 2) lineName: '6' id: '611' name: 'Yeokchon' secondName: nil! !

JhcLineRealDataTest subclass: #JhcLine7Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol-RealData'!

!JhcLine7Test methodsFor: 'running' stamp: 'hjo 10/10/2009 09:23'!
setUp

	super setUp.
	line := JhcLine line7! !

!JhcLine7Test methodsFor: 'station' stamp: 'hjo 10/31/2009 15:34'!
testChildrensGrandPark

	self assertStation: (line stations at: 18) lineName: '7' id: '726' name: 'Children''s Grand Park' secondName: 'Sejong Univ.'! !

!JhcLine7Test methodsFor: 'station' stamp: 'hjo 10/31/2009 15:35'!
testDobongsan

	self assertStation: (line stations at: 2) lineName: '7' id: '710' name: 'Dobongsan' secondName: nil! !

!JhcLine7Test methodsFor: 'routing' stamp: 'hjo 11/9/2009 22:59'!
testFirstStationIsConnected

	self assert: line stations first neighbors size = 1! !

!JhcLine7Test methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:35'!
testFromJunghwaToCheongdam

	self assert: (self timeFrom: 'Junghwa' to: 'Cheongdam') equals: 20! !

!JhcLine7Test methodsFor: 'routing' stamp: 'hjo 11/9/2009 22:59'!
testIntermediateStationIsConnectedTwice

	line stations copyWithoutFirst copyWithoutLast
		do: [:each| self assert: each neighbors size = 2]! !

!JhcLine7Test methodsFor: 'station' stamp: 'hjo 10/31/2009 15:35'!
testJangam

	self assertStation: (line stations at: 1) lineName: '7' id: '709' name: 'Jangam' secondName: nil! !

!JhcLine7Test methodsFor: 'routing' stamp: 'hjo 11/9/2009 23:00'!
testLastStationIsConnected

	self assert: line stations last neighbors size = 1! !

!JhcLine7Test methodsFor: 'etc' stamp: 'hjo 10/13/2009 14:42'!
testLineColor
	
	"RGB 84,100,13"
	self assert: line lineColor equals: (Color r:84/255 g:100/255 b:13/255)! !

!JhcLine7Test methodsFor: 'station' stamp: 'hjo 10/31/2009 15:36'!
testOnsu

	self assertStation: (line stations at: 42) lineName: '7' id: '750' name: 'Onsu' secondName: 'Sungkonghoe Univ.'! !

!JhcLine7Test methodsFor: 'station' stamp: 'hjo 10/31/2009 15:36'!
testSuraksan

	self assertStation: (line stations at: 3) lineName: '7' id: '711' name: 'Suraksan' secondName: nil! !

JhcLineRealDataTest subclass: #JhcLine8Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol-RealData'!

!JhcLine8Test methodsFor: 'running' stamp: 'hjo 9/28/2009 13:16'!
setUp

	super setUp.
	line := JhcLine line8! !

!JhcLine8Test methodsFor: 'station' stamp: 'hjo 10/31/2009 15:37'!
testAmsa

	self assertStation: (line stations at: 1) lineName: '8' id: '810' name: 'Amsa' secondName: nil! !

!JhcLine8Test methodsFor: 'station' stamp: 'hjo 10/31/2009 15:37'!
testJamsil

	self assertStationAtName: 'Jamsil' id: '814' lineName: '8' secondName: 'Songpa-gu Office'! !

!JhcLine8Test methodsFor: 'etc' stamp: 'hjo 10/13/2009 14:44'!
testLineColor

	"RGB: 245,19,97"
	self assert: line lineColor equals: (Color r:245/255 g:19/255 b:97/255)! !

!JhcLine8Test methodsFor: 'station' stamp: 'hjo 10/31/2009 15:38'!
testSongpa

	self assertStation: (line stations at: 7) lineName: '8' id: '816' name: 'Songpa' secondName: nil! !

!JhcLine8Test methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:28'!
testTimeSpanFromAmsaToSongpa

	self assert: (self timeFrom: 'Amsa' to: 'Songpa') equals: 13! !

!JhcLine8Test methodsFor: 'routing' stamp: 'hjo 10/12/2009 13:31'!
testTimeSpanFromBokjeongToSanseong

	self assert: (self timeFrom: 'Bokjeong' to: 'Sanseong') equals: 4! !

JhcLineRealDataTest subclass: #JhcLine9FastTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol-RealData'!

!JhcLine9FastTest methodsFor: 'running' stamp: 'hjo 10/28/2009 19:18'!
setUp

	super setUp.
	line := JhcLine line9Fast! !

!JhcLine9FastTest methodsFor: 'routing' stamp: 'hjo 10/29/2009 04:09'!
testFromGimpoToSinnonhyeon

	self assert: (self timeFrom: 'Gimpo Int''l Airport' to: 'Sinnonhyeon') equals: 31! !

!JhcLine9FastTest methodsFor: 'stations' stamp: 'hjo 10/31/2009 15:39'!
testGimpoIntlAirport

	self assertStationAtName: 'Gimpo Int''l Airport' id: '902' lineName: '9-fast' secondName: nil ! !

!JhcLine9FastTest methodsFor: 'etc' stamp: 'hjo 10/28/2009 18:33'!
testLineColor

	"RGB: 170,152,114"
	self assert: line lineColor equals: (Color r: 170/255 g:152/255 b:114/255)! !

JhcLineRealDataTest subclass: #JhcLine9SlowTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol-RealData'!

!JhcLine9SlowTest methodsFor: 'running' stamp: 'hjo 10/28/2009 19:18'!
setUp

	super setUp.
	line := JhcLine line9Slow! !

!JhcLine9SlowTest methodsFor: 'routing' stamp: 'hjo 10/29/2009 04:11'!
testFromJeungmiToGubanpo

	self assert: (self timeFrom: 'Jeungmi' to: 'Gubanpo')equals: 26! !

!JhcLine9SlowTest methodsFor: 'stations' stamp: 'hjo 10/31/2009 16:28'!
testGaehwa

	self assertStationAtName: 'Gaehwa' id: '901' lineName: '9-slow' secondName: nil ! !

!JhcLine9SlowTest methodsFor: 'stations' stamp: 'hjo 10/31/2009 16:28'!
testGimpoIntlAirport

	self assertStationAtName: 'Gimpo Int''l Airport' id: '902' lineName: '9-slow' secondName: nil ! !

!JhcLine9SlowTest methodsFor: 'stations' stamp: 'hjo 10/31/2009 16:29'!
testHeukseok

	self assertStationAtName: 'Heukseok' id: '919' lineName: '9-slow' secondName: 'Chung-ang Univ.'! !

!JhcLine9SlowTest methodsFor: 'etc' stamp: 'hjo 10/13/2009 14:46'!
testLineColor

	"RGB: 170,152,114"
	self assert: line lineColor equals: (Color r: 170/255 g:152/255 b:114/255)! !

JhcLineRealDataTest subclass: #JhcLine9Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol-RealData'!

!JhcLine9Test methodsFor: 'running' stamp: 'hjo 10/28/2009 19:21'!
setUp

	super setUp.
	line := JhcLine line9! !

!JhcLine9Test methodsFor: 'routing' stamp: 'hjo 10/31/2009 14:06'!
testFastLineIsFaster

	self assert: 
	
	((line stationAtName: 'Gayang' lineName: '9-fast') timespanMinutesTo: (line stationAtName: 'Dongjak' lineName: '9-fast')) <  ((line stationAtName: 'Gayang' lineName: '9-slow') timespanMinutesTo: (line stationAtName: 'Dongjak' lineName: '9-slow'))! !

!JhcLine9Test methodsFor: 'routing' stamp: 'hjo 10/31/2009 14:06'!
testFromGayangToDongjakFast

	self assert: ((line stationAtName: 'Gayang' lineName: '9-fast') timespanMinutesTo: (line stationAtName: 'Dongjak' lineName: '9-fast')) equals: 17! !

!JhcLine9Test methodsFor: 'routing' stamp: 'hjo 10/31/2009 14:06'!
testFromGayangToDongjakSlow

	self assert: ((line stationAtName: 'Gayang' lineName: '9-slow') timespanMinutesTo: (line stationAtName: 'Dongjak' lineName: '9-slow')) equals: 26! !

!JhcLine9Test methodsFor: 'stations' stamp: 'hjo 10/31/2009 16:30'!
testGaehwa

	self assertStationAtName: 'Gaehwa' id: '901' lineNames: #('9-slow') secondName: nil ! !

!JhcLine9Test methodsFor: 'stations' stamp: 'hjo 10/31/2009 16:50'!
testGimpoIntlAirport

	self assertStationAtName: 'Gimpo Int''l Airport' id: '902' lineNames: #('9-slow' '9-fast') secondName: nil ! !

!JhcLine9Test methodsFor: 'stations' stamp: 'hjo 10/31/2009 16:33'!
testHeukseok

	self assertStationAtName: 'Heukseok' id: '919' lineNames:  #('9-slow') secondName: 'Chung-ang Univ.' ! !

!JhcLine9Test methodsFor: 'stations' stamp: 'hjo 10/28/2009 19:22'!
testLineColor

	"RGB: 170,152,114"
	self assert: line lineColor equals: (Color r: 170/255 g:152/255 b:114/255)! !

!JhcLineRealDataTest classSide methodsFor: 'as yet unclassified' stamp: 'hjo 10/12/2009 13:25'!
isAbstract

	^self name = #JhcLineRealDataTest! !

!JhcLineRealDataTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/31/2009 14:14'!
assertStation: aJhcStation lineName: expectedLineName id: expectedStationId name: expectedStationName secondName: expectedSecondName

	self assert: aJhcStation lineName equals: expectedLineName.
	self assert: aJhcStation id equals: expectedStationId.
	self assert: aJhcStation name equals: expectedStationName.
	self assert: aJhcStation secondName equals: expectedSecondName
	
! !

!JhcLineRealDataTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/10/2009 13:56'!
assertStationAtName: aByteString id: expectedStationId lineName: expectedLineName secondName: expectedSecondName 

	| station |
	station := line stationAtName: aByteString.
	self assert: station name equals: aByteString.
	self assert: station id equals: expectedStationId.
	self assert: station lineName equals: expectedLineName.
	self assert: station secondName equals: expectedSecondName! !

!JhcLineRealDataTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/31/2009 16:51'!
assertStationAtName: aByteString id: expectedStationId lineNames: expectedLineNames secondName: expectedSecondName 

	| station |
	station := line stationAtName: aByteString.
	self assert: station name equals: aByteString.
	self assert: station id equals: expectedStationId.
	self assert: station lineNames equalsArray: expectedLineNames.
	self assert: station secondName equals: expectedSecondName! !

!JhcLineRealDataTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/9/2009 14:55'!
pathsFrom: stationName1 to: stationName2 

	^(line stationAtName: stationName2) minimumTimeCostPathsFrom: (line stationAtName: stationName1)
	! !

!JhcLineRealDataTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/6/2009 19:58'!
timeFrom: from to: to
	| fromStation toStation |
	line stations do: [:each| each clearMinimumCostPaths].
	fromStation := line stationAtName: from.
	toStation := line stationAtName: to.
	^fromStation timespanMinutesTo: toStation! !

JhcLineRealDataTest subclass: #JhcSplittingLineTest
	instanceVariableNames: 'split fork1 fork2 root line1 line2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcSplittingLineTest commentStamp: 'jhan 10/19/2009 22:46' prior: 0!
This test case tests the situation of line number 5 and line number 1. Each of these two lines is splitted into two for different directions. In this case the travel from main trunk to one of branches does not require a transfer, however the traver from one branch to the other needs a transfer at splitting station. 

Jooyung's opinion: With this situation I modeled the main line consists of two sub-lines. The model solves the problem in simple way, and I think this model represents correctly the real situation.!

!JhcSplittingLineTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/9/2009 18:14'!
setUp
	"
	'split' is the station where the line splits into two lines; one for 'fork1'
	and the other for 'fork2'.
	'root' station is connected to 'split'. people can go from 'root' to 'fork1'
	without transfer. they can also go from 'root' to 'fork2' without
	transfer. but they cannot go from 'fork1' to 'fork2' directly. they need
	to transfer at 'split' station.
	"
	line1 := JhcLine new.
	line1 lineName: 'line-fork1'.
	
	line2 := JhcLine new.
	line2 lineName: 'line-fork2'.
	
	line1 addStationsWithNamesAndCosts: #('root' 1 'split' 3 'fork1').
	line2 addStationsWithNamesAndCosts: #('root' 1 'split' 5 'fork2').
	
	"main line consists of two sub lines. Each of sublines represents the branches"
	
	"Do we need a JhcCompositeLine?"
	line := JhcLine new.
	line stations addAll: line1 stations.
	line stations addAll: line2 stations.
	
	"we can connect the splitting station to become a transfer station"
	(line1 stationAtName: 'split') connectSplittingStation: (line2 stationAtName: 'split') cost: 200.! !

!JhcSplittingLineTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/20/2009 11:15'!
testFromFork1ToFork2
  "fork1 -> 3 -> split -> 200 -> split -> 5 -> fork2"
	self assert: (self timeFrom: 'fork1' to: 'fork2') equals: 208.
	self assert: (self timeFrom: 'fork2' to: 'fork1') equals: 208.! !

!JhcSplittingLineTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/19/2009 22:02'!
testFromRootToFork1
	self assert: (self timeFrom: 'root' to: 'fork1') equals: 4.
	self assert: (self timeFrom: 'fork1' to: 'root') equals: 4.! !

!JhcSplittingLineTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/19/2009 22:26'!
testFromRootToFork2
	self assert: (self timeFrom: 'root' to: 'fork2') equals: 6.
	self assert: (self timeFrom: 'fork2' to: 'root') equals: 6.! !

!JhcSplittingLineTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/20/2009 11:20'!
testWithOrWithoutTransfer

	self assert: (self timeFrom: 'root' to: 'fork2') + (self timeFrom: 'fork2' to: 'root') + (self timeFrom: 'root' to: 'fork1') equals: 16.
	self assert: (self timeFrom: 'fork1' to: 'fork2') equals: 208.
	! !

TestCase subclass: #JhcLineTest
	instanceVariableNames: 'line'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLineTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/31/2009 14:07'!
testLoadInput
	| input |
	input := '310	Daehwa	0'.
	line := JhcLine loadData: input for: '3'.
	self assert: (line lineName = '3').
	self assert: line stations size equals: 1.
	self assert: line stations first id equals: '310'.! !

!JhcLineTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/11/2009 23:43'!
testReadStream
	| lines |
	
	lines := '3
abc	def	ghi' lines.
	self assert: (lines size = 2)
	! !

TestCase subclass: #JhcRoutingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcRoutingTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/9/2009 22:51'!
testBundangLine

	| line |
	line := OrderedCollection new.
	line add: (JhcStation newName: 'Seolleung' line: 'Bundang' id: 'K215').
	line add: (JhcStation newName: 'Hanti' line: 'Bundang' id: 'K216').
	line add: (JhcStation newName: 'Dogok' line: 'Bundang' id: 'K217').
	line add: (JhcStation newName: 'Guryong' line: 'Bundang' id: 'K218').
	line add: (JhcStation newName: 'Gaepo-dong' line: 'Bundang' id: 'K219').
	line add: (JhcStation newName: 'Daemosan' line: 'Bundang' id: 'K220').
	line add: (JhcStation newName: 'Suseo' line: 'Bundang' id: 'K221').
	line add: (JhcStation newName: 'Bokjeong' line: 'Bundang' id: 'K222').
	line add: (JhcStation newName: 'Kyungwon Univ.' line: 'Bundang' id: 'K223').
	line add: (JhcStation newName: 'Taepyeong' line: 'Bundang' id: 'K224').
	line add: (JhcStation newName: 'Moran' line: 'Bundang' id: 'K225').
	line add: (JhcStation newName: 'Yatap' line: 'Bundang' id: 'K226').
	line add: (JhcStation newName: 'Imae' line: 'Bundang' id: 'K227').
	line add: (JhcStation newName: 'Seohyeon' line: 'Bundang' id: 'K228').
	line add: (JhcStation newName: 'Sunae' line: 'Bundang' id: 'K229').
	line add: (JhcStation newName: 'Jeongja' line: 'Bundang' id: 'K230').
	line add: (JhcStation newName: 'Migeum' line: 'Bundang' id: 'K231').
	line add: (JhcStation newName: 'Ori' line: 'Bundang' id: 'K232').
	line add: (JhcStation newName: 'Jukjeon' line: 'Bundang' id: 'K233').
	line add: (JhcStation newName: 'Bojeong' line: 'Bundang' id: 'K234').

	line doCouple: [:a :b| a connect: b cost: 2 ].
	
	self assert: ((line at:1) timespanMinutesTo: (line at:15)) equals: 28! !

!JhcRoutingTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/9/2009 22:51'!
testLine8

	| line |
	line := OrderedCollection new.
	line add: (JhcStation newName: 'Amsa' line: '8' id: '810').
	line add: (JhcStation newName: 'Cheonho(Pungnaptoseong)' line: '8' id: '811').
	line add: (JhcStation newName: 'Gangdong-gu Office' line: '8' id: '812').
	line add: (JhcStation newName: 'Mongchontoseong(World Peace Gate)' line: '8' id: '813').
	line add: (JhcStation newName: 'Jamsil(Songpa-gu Office)' line: '8' id: '814').
	line add: (JhcStation newName: 'Seokchon' line: '8' id: '815').
	line add: (JhcStation newName: 'Songpa' line: '8' id: '816').
	line add: (JhcStation newName: 'Garak Market' line: '8' id: '817').
	line add: (JhcStation newName: 'Munjeong' line: '8' id: '818').
	line add: (JhcStation newName: 'Jangji' line: '8' id: '819').
	line add: (JhcStation newName: 'Bokjeong' line: '8' id: '820').
	line add: (JhcStation newName: 'Sanseong' line: '8' id: '821').
	line add: (JhcStation newName: 'Namhansanseong(Seongnam Court & Public Prosecutor''s Office)' line: '8' id: '822').
	line add: (JhcStation newName: 'Dandaegogeori' line: '8' id: '823').
	line add: (JhcStation newName: 'Sinheung' line: '8' id: '824').
	line add: (JhcStation newName: 'Sujin' line: '8' id: '825').
	line add: (JhcStation newName: 'Moran' line: '8' id: '826').

	line doCouple: [:a :b| a connect: b cost: 2 ].
	
	self assert: ((line at:10) timespanMinutesTo: (line at:15)) equals: 10! !

!JhcRoutingTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/9/2009 22:56'!
testOneSegment

	| s t |
	s := JhcStation newName: 'Hapjeong' line: 2 id: 238.
	t := JhcStation newName: 'HongIk Univ.' line: 2 id: 239.

	s connect: t cost: 2.
	self assert: (s timespanMinutesTo: t) equals:2! !

!JhcRoutingTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/9/2009 23:07'!
testStationAndPlatformHandshake

	| station |
	station := JhcStation new.
	self assert: (station platform1 station == station).
	self assert: (station platform2 station == station)! !

!JhcRoutingTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/9/2009 22:53'!
testTransferFromBundangLineToLine8AtBokjeong

	| line8 bundangLine |
	line8 := OrderedCollection new.
	line8 add: (JhcStation newName: 'Munjeong' line: '8' id: '818').
	line8 add: (JhcStation newName: 'Jangji' line: '8' id: '819').
	line8 add: (JhcStation newName: 'Bokjeong' line: '8' id: '820').
	line8 add: (JhcStation newName: 'Sanseong' line: '8' id: '821').
	line8 add: (JhcStation newName: 'Namhansanseong' secondName: 'Seongnam Court & Public Prosecutor''s Office' line: '8' id: '822').

	line8 doCouple: [:a :b| a connect: b cost: 2 ].
	
	bundangLine := OrderedCollection new.
	bundangLine add: (JhcStation newName: 'Gaepo-dong' line: 'Bundang' id: 'K219').
	bundangLine add: (JhcStation newName: 'Daemosan' line: 'Bundang' id: 'K220').
	bundangLine add: (JhcStation newName: 'Suseo' line: 'Bundang' id: 'K221').
	bundangLine add: (JhcStation newName: 'Bokjeong' line: 'Bundang' id: 'K222').
	bundangLine add: (JhcStation newName: 'Kyungwon Univ.' line: 'Bundang' id: 'K223').
	bundangLine add: (JhcStation newName: 'Taepyeong' line: 'Bundang' id: 'K224').
	bundangLine add: (JhcStation newName: 'Moran' line: 'Bundang' id: 'K225').

	bundangLine doCouple: [:a :b| a connect: b cost: 2 ].
	(line8 at: 3) connectSplittingStation: (bundangLine at: 4) cost: 7. "transfer link"
	
	self assert: (line8 first timespanMinutesTo: bundangLine last) equals: 17! !

!JhcRoutingTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/9/2009 22:55'!
testTwoSegment

	| s t u |
	s := JhcStation newName: 'Hapjeong' line: 2 id: 238.
	t := JhcStation newName: 'HongIk Univ.' line: 2 id: 239.
	u := JhcStation newName: 'ShinChon' line: 2 id: 240.

	s connect: t cost: 2.
	t connect: u cost: 2.
	self assert: (s timespanMinutesTo: u) equals: 4! !

TestCase subclass: #JhcStationSelectTest
	instanceVariableNames: 'subway'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcStationSelectTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/19/2009 19:21'!
setUp

	super setUp.
	subway := JhcSubway new! !

!JhcStationSelectTest methodsFor: 'filtering' stamp: 'jhan 11/1/2009 16:02'!
testAllLinesShouldHaveLineName
	| line |
	#(bundang line1 line2 line3 line4 line5 line6 line7 line8 line9)
			do: [:instantiationMethod| 
				line := JhcLine perform: instantiationMethod.
				self assert: line lineName isNil = false 
				 ]! !

!JhcStationSelectTest methodsFor: 'filtering' stamp: 'hjo 10/20/2009 15:34'!
testFilterIsCaseInsensitive

	| filteredSize |
	filteredSize := [:string | subway filterBy: string. subway filteredStations size ].
	self assert: ((filteredSize value: 'Sin') = (filteredSize value: 'siN')).
	self deny: ((filteredSize value: 'si') = (filteredSize value: 'inn')).! !

!JhcStationSelectTest methodsFor: 'filtering' stamp: 'hjo 10/19/2009 19:34'!
testFilterStations

	self assert: subway filteredStations size equals: subway stations size.
	
	subway filterBy: 'Sin'.
	self assert: subway filteredStations size < subway stations size! !

!JhcStationSelectTest methodsFor: 'as yet unclassified' stamp: 'jhan 11/1/2009 15:47'!
testStations

	"This test can be changed whenever the station data is gathered."
	self assert: subway stations size equals: 392! !

TestCase subclass: #JhcTransferStationTest
	instanceVariableNames: 'line2 seongsu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcTransferStationTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/13/2009 10:04'!
setUp
	line2 := JhcLine line2.
	seongsu := line2 stationAtName: 'Seongsu'! !

!JhcTransferStationTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/31/2009 14:04'!
testStationAtNameLine

	self deny: (line2 stationAtName: 'Seongsu' lineName: '2') == (line2 stationAtName: 'Seongsu' lineName: '2-seongsu-branch').
	self assert: (line2 stationAtName: 'Seongsu' lineName: '2') == (line2 stationAtName: 'Seongsu' lineName: '2')! !

!JhcTransferStationTest methodsFor: 'as yet unclassified' stamp: 'jhan 10/13/2009 10:07'!
testTransferStationHasIdenticalNameAndIdOfItsSubStations
	self assert:  seongsu name equals: 'Seongsu'.
	self assert:  seongsu id equals: '211'.! !

!JhcTransferStationTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/31/2009 14:04'!
testTransferTimespan

	self 
		assert: 
			((line2 stationAtName: 'Seongsu' lineName: '2') timespanMinutesTo:
	(line2 stationAtName: 'Seongsu' lineName: '2-seongsu-branch'))
		equals: 11! !

TestCase subclass: #KeyedObjectAccessorTest
	instanceVariableNames: 'accessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol-Helpers'!

!KeyedObjectAccessorTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/12/2009 17:46'!
testSetArrayIndicesAs

	accessor := KeyedObjectAccessor new.
	accessor setArrayIndicesAs: #(id stationName timespan).
	accessor object: #('238' 'YongSan' '4').

	self assert: accessor id equals: '238'.
	self assert: accessor stationName equals: 'YongSan'.
	self assert: accessor timespan equals: '4'.
! !

!KeyedObjectAccessorTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/12/2009 17:33'!
testSetKeyAndAccessor

	accessor := KeyedObjectAccessor new.
	accessor setKey: 1 as: #id.
	accessor object: #('238').

	self assert: accessor id equals: '238'! !

!KeyedObjectAccessorTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/12/2009 17:40'!
testSetKeyAndAccessor2

	accessor := KeyedObjectAccessor new.
	accessor setKey: 1 as: #id.
	accessor setKey: 2 as: #stationName.
	accessor object: #('238' 'YongSan').

	self assert: accessor id equals: '238'.
	self assert: accessor stationName equals: 'YongSan'! !

!KeyedObjectAccessorTest methodsFor: 'as yet unclassified' stamp: 'hjo 10/12/2009 17:42'!
testSetKeyAndAccessor3

	accessor := KeyedObjectAccessor new.
	accessor setKey: 1 as: #id.
	accessor setKey: 2 as: #stationName.
	accessor setKey: 3 as: #timespan.
	accessor object: #('238' 'YongSan' '4').

	self assert: accessor id equals: '238'.
	self assert: accessor stationName equals: 'YongSan'.
	self assert: accessor timespan equals: '4'.
! !

Object subclass: #IntegerStream
	instanceVariableNames: 'current'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol-Helpers'!

!IntegerStream methodsFor: 'as yet unclassified' stamp: 'hjo 10/7/2009 21:00'!
current: aSmallInteger 

	current := aSmallInteger ! !

!IntegerStream methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 00:35'!
initialize
	current := 0! !

!IntegerStream methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 00:35'!
next
	|ret|
	ret := current.
	current := current + 1.
	^ret! !

Object subclass: #JhcLine
	instanceVariableNames: 'idPrefix stations integerStream lineColor lineName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/31/2009 17:06'!
bundang

	| inst |
	inst := self new.
	inst lineName: 'Bundang'.
	inst idPrefix: 'K'.
	inst setIntegerForFirstStationId: 215.
	inst lineColor: (Color r: 255/255 g: 179/255 b: 0/255).
	
	inst addStationsWithNamesAndCosts: #('Seolleung' 2 'Hanti' 2 'Dogok' 2 'Guryong' 2 'Gaepo-dong' 2 'Daemosan' 4 'Suseo' 4 'Bokjeong' 3 'Kyungwon Univ.' 2 'Taepyeong' 2 'Moran' 3 'Yatap' 3 'Imae' 2 'Seohyeon' 2 'Sunae' 3 'Jeongja' 3 'Migeum' 2 'Ori' 3 'Jukjeon' 2 'Bojeong').
	^inst! !

!JhcLine classSide methodsFor: 'instance helper' stamp: 'hjo 10/10/2009 15:17'!
connctStations: anArray withMinuteStream: aReadStream 

	self assert: [aReadStream size + 1 = anArray size ] description: 'number of edges are one less than number of vertices.'.
	anArray doCouple: [:a :b| a connect: b cost: aReadStream next ]! !

!JhcLine classSide methodsFor: 'instance helper' stamp: 'hjo 10/23/2009 17:32'!
connctWithDirectionStations: anArray withMinuteStream: aReadStream 

	self assert: [aReadStream size + 1 = anArray size ] description: 'number of edges are one less than number of vertices.'.
	anArray doCouple: [:a :b| a connectTo: b cost: aReadStream next ]! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/13/2009 13:57'!
line1

	| string instance |
	string := 
'133	Seoul Station	0
132	City Hall	2
131	Jonggak	3
130	Jongno 3(sam)-ga	1
129	Jongno 5(o)-ga	2
128	Dongdaemun	2
127	Dongmyo	2
126	Sinseol-dong	1
125	Jegi-dong	2
124	Cheongnyangni	2
'
.
	instance := 	self loadData: string for: '1'.
	instance lineColor: (Color r: 13/255 g: 54/255 b: 146/255).
	^instance! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 11/10/2009 12:32'!
line2

	| ring seongsu sinjeong instance |
	ring := self line2Ring.
	seongsu := self line2SeongsuBranch.
	sinjeong := self line2SinjeongBranch.
	instance := self new.
	instance lineName: '2'.

	instance stations addAll: ring stations.
	instance stations addAll: seongsu stations.
	instance stations addAll: sinjeong stations.

	(ring stationAtId: '234') connectSplittingStation: (sinjeong stationAtId: '234') cost: 13.
	(seongsu stationAtId: '211') connectSplittingStation: (ring stationAtId: '211') cost: 11.

	instance lineColor: (Color r: 51/255 g: 162/255 b: 61/255).
	^instance! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/31/2009 16:54'!
line2Ring

	| instance |
	instance := self new.
	instance lineName: '2'.
	instance idPrefix: ''.
	instance setIntegerForFirstStationId: 201.
	
	#('City Hall' 'Euljiro 1(il)-ga' 'Euljiro 3(sam)-ga' 'Euljiro 4(sa)-ga' 'Dongdaemun Stadium' 'Sindang' 'Sangwangsimni' 'Wangsimni' 'Hanyang Univ.' 'Ttukseom' 'Seongsu' 'Konkuk Univ.' 
	('Guui'   'Gwangjin-gu Office') ('Gangbyeon'   'Dongseoul Bus Terminal')  'Seongnae'  ('Jamsil' 'Songpa-gu Office') 'Sincheon'  'Sports Complex'   ('Samseong'  'World Trade Center Seoul')
	'Seolleung' 'Yeoksam' 'Gangnam' ('Seoul Nat''l Univ. of Education' 'Court &Public Prosecutor''s Office') 'Seocho' 'Bangbae' 'Sadang' 'Nakseongdae' ('Seoul Nat''l Univ.'  'Gwanak-gu Office')
	'Bongcheon' 'Sillim' 'Sindaebang' 'Guro Digital Complex' ('Daerim' 'Guro-gu Office') 'Sindorim' 'Mullae' 'Yeongdeungpo-gu Office' 'Dangsan' 'Hapjeong' 'Hongik Univ.' 'Sinchon' 
	'Ewha Womans Univ.' 'Ahyeon' ('Chungjeongno' 'Kyonggi Univ.'))
		do: [:each| each isString ifTrue:  [instance addStationNamed: each] ifFalse: [ instance addStationNamed: each first secondName: each second ] ].

	instance connectStationsInRange: (1 to: 43), (Array with: 1) withEdgesWithTimeSpanMinutes:  #(2 2 1 2 2 2 1 2 3 1 2 3 2 3 3 2 2 2 2 2 2 2 1 3 3 2 2 2 2 2 2 2 3 3 1 2 4 2 3 2 1 2 2).
	instance lineColor: (Color r: 51/255 g: 162/255 b: 61/255).

	^instance! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/31/2009 16:54'!
line2SeongsuBranch

	| instance accessor |
	instance := self new.
	instance lineName: '2-seongsu-branch'.
	
	accessor := KeyedObjectAccessor new.
	accessor setArrayIndicesAs: #(stationName secondName id).
	#(
		('Seongsu' nil '211')
		('Yongdap' nil '211-1')
		('Sindap' nil '211-2')
		('Yongdu' 'Dongdaemun-gu Office' '211-3')
		('Sinseol-dong' nil '211-4')
	)
		do: [:data| 
			accessor object: data.
			instance addStationNamed: accessor stationName secondName: accessor secondName id: accessor id.
			].
	instance connectStationsWithEdgesWithTimeSpanMinutes: #(3 2 2 2).
	instance lineColor: (Color r: 51/255 g: 162/255 b: 61/255).
	^instance
	! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/31/2009 16:54'!
line2SinjeongBranch

	| instance |
	instance := self new.
	instance lineName: '2-sinjeong-branch'.
	
	#(
		('Sindorim' '234')
		('Dorimcheon' '234-1')
		('Yangcheon-gu Office' '234-2')
		('Sinjeongnegeori' '234-3')
		('Kkachisan' '234-4')
	)
		do: [:data| 
			instance addStationNamed: data first id: data second ].
	instance connectStationsWithEdgesWithTimeSpanMinutes: #(2 3 4 3).
	instance lineColor: (Color r: 51/255 g: 162/255 b: 61/255).
	^instance
	! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/31/2009 14:05'!
line3

	| instance |
	instance := self new.
	instance lineName: '3'.
	instance lineColor: (Color r:254/255 g:91/255 b:16/255).
	instance setIntegerForFirstStationId: 310.
	
	instance addStationsWithNamesAndCosts:
	#('Daehwa' 3 'Juyeop' 3 'Jeongbalsan' 2 'Madu' 2 'Baekseok' 4  'Daegok' 3 'Hwajeong' 3 'Wondang' 5 'Samsong' 3 'Jichuk' 2 'Gupabal' 2  'Yeonsinnae' 2 'Bulgwang'  2  'Nokbeon' 3 'Hongje' 2
'Muakjae'  2  'Dongnimmun'  2 'Gyeongbokgung' 2  'Anguk' 2  'Jongno 3(sam)-ga'
2 'Euljiro 3(sam)-ga'  1  'Chungmuro'  2 'Dongguk Univ.' 2  'Yaksu' 1  'Geumho'  2 'Oksu'
2 'Apgujeong' 3  'Sinsa' 2  'Jamwon' 2 'Express Bus Terminal' 2 'Seoul Nat''l Univ. of Education'
 2 'Nambu Bus Terminal'  3  'Yangjae' 2  'Maebong' 2  'Dogok'  2 'Daechi' 1 'Hangnyeoul' 2
'Daecheong' 2  'Irwon'  3 'Suseo').

	instance giveStationNamed: 'Gyeongbokgung' aSecondName: 'Central Government Complex'.
	instance giveStationNamed: 'Seoul Nat''l Univ. of Education' aSecondName: 'Court & Public Prosecutor''s Office'.
	instance giveStationNamed: 'Nambu Bus Terminal' aSecondName: 'Seoul Arts Center'.
	instance giveStationNamed: 'Yangjae' aSecondName: 'Seocho-gu Office'.

	^instance! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/31/2009 14:04'!
line4
	

| instance |
	instance := self new.
	instance lineName: '4'.
	instance lineColor: (Color r:50/255 g:161/255 b:200/255 ).
	instance setIntegerForFirstStationId: 409.
	
	instance addStationsWithNamesAndCosts:
	 #('Danggogae' 2 'Sanggye' 2 'Nowon' 3 'Chang-dong' 2 'Ssangmun' 2 'Suyu' 2 'Mia' 3 'Miasamgeori' 2 'Gireum' 2 'Sungshin Woman''s Univ.' 2 'Hansung Univ.' 2 'Hyehwa' 3 'Dongdaemun' 1 'Dongdaemun Stadium' 3 'Chungmuro' 1 'Myeong-dong' 2 'Hoehyeon' 2 'Seoul Station' 2 'Sookmyung Women''s Univ.' 2 'Samgakji' 1 'Sinyongsan' 2 'Ichon' 4 'Dongjak' 3 'Isu' 2 'Sadang'  2 'Namtaeryeong' 3 'Seonbawi' 2 'Seoul Racecourse Park' 2 'Seoul Grand Park' 2 'Gwacheon' 2 'Government Complex Gwacheon' 4 'Indeogwon' 3 'Pyeongchon' 2 'Beomgye' 3 'Geumjeong' 5 'Sanbon' 1 'Surisan' 3 'Daeyami' 2 'Banwol' 4 'Sangnoksu' 2 'Hanyang Univ. at Ansan' 2 'Jungang' 2 'Gojan' 3 'Gongdan' 4 'Ansan' 3 'Singil oncheon' 3 'Jeongwang' 3 'Oido').

	#(
		( 'Sungshin Woman''s Univ.'  'Donam' )
		('Hansung Univ.'  'Samseongyo')
		('Hoehyeon'  'Namdaemun Market')
		('Dongjak' 'Seoul National Cemetery')
		('Sookmyung Women''s Univ.' 'Garwol')
		('Isu' 'Chongshin Univ.')
		('Seoul Grand Park'  'Seoul Land')
		('Jeongwang' 'Korea Polytechnic Univ.')
	) do: [:array| 
		[:appName :secondName | instance giveStationNamed: appName aSecondName: secondName ] valueWithArguments: array
	].
	 ^instance! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'jhan 11/1/2009 16:12'!
line5
	
	| instance macheonLine sangilDongLine commonStationNames |
	instance := self new.
	instance lineName: '5'.
	instance lineColor: (Color r: 139/255 g: 80/255 b: 164/255 ).
	macheonLine := self line5MacheonBranch.
	sangilDongLine := self line5SangilDongBranch.
	
	instance stations addAll: macheonLine stations.
	instance stations addAll: sangilDongLine stations.
	
	commonStationNames := (macheonLine stations collect: [:each| each name ]) intersection: (sangilDongLine stations collect: [:each| each name ]).
	commonStationNames do: [:each| (macheonLine stationAtName: each) connect: (sangilDongLine stationAtName: each) cost: 8. self revisit: 'This is not real data.' ].
	
	^instance! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/22/2009 14:45'!
line5MacheonBranch
	
	| instance |
	instance := self line5Prebuild: '5-macheon'.
	
	#(
		('P549' 'Dunchon-dong')
		('P550' 'Olympic Park')
		('P551' 'Bangi')
		('P552' 'Ogeum')
		('P553' 'Gaerong')
		('P554' 'Geoyeo')
		('P555' 'Macheon')
	)
		do: [:array| [ :idString :nameString  | instance addStationNamed: nameString id: idString ]
			valueWithArguments: array ].

	instance connectWithStationNamesAndCosts: 
#('Gangdong' 2 'Dunchon-dong' 2 'Olympic Park' 2 'Bangi' 2 'Ogeum' 2 'Gaerong' 2 'Geoyeo' 2 'Macheon').

	#(
		('Olympic Park'  'Korean National Univ. of Physical Education')
	) do: [:array|
		[:stationName :secondName | instance giveStationNamed: stationName aSecondName:  secondName ] valueWithArguments: array].

	^instance! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/31/2009 14:05'!
line5Prebuild: lineName
	
	| instance |
	instance := self new.
	instance lineColor: (Color r: 139/255 g: 80/255 b: 164/255 ).
	instance lineName: lineName.
	
	instance setIntegerForFirstStationId: 510.
	instance addStationsWithNamesAndCosts:
#('Banghwa' 2 'Gaehwasan' 2 'Gimpo Int''l Airport' 3 'Songjeong' 2 'Magok' 1 'Balsan' 2 'Ujangsan' 2 'Hwagok' 2 'Kkachisan' 2 'Sinjeong' 2 'Mok-dong' 1 'Omokgyo' 2 'Yangpyeong' 2 'Yeongdeungpo-gu Office' 2 'Yeongdeungpo Market' 2 'Singil' 1 'Yeouido' 2 'Yeouinaru' 3 'Mapo' 1 'Gongdeok' 2 'Aeogae' 2 'Chungjeongno' 2 'Seodaemun' 2 'Gwanghwamun' 2 'Jongno 3(sam)-ga' 2 'Euljiro 4(sa)-ga' 2 'Dongdaemun Stadium' 2 'Cheonggu'  1 'Singeumho' 2 'Haengdang' 2 'Wangsimni' 1 'Majang' 2 'Dapsimni' 2 'Janghanpyeong' 3 'Gunja'  2 'Achasan' 2 'Gwangnaru' 3 'Cheonho' 2 'Gangdong').
		
	#(
		('Sinjeong' 'Eunhaengjeong')
		('Omokgyo' 'Mok-dong Stadium')
		('Chungjeongno' 'Kyonggi Univ.')
		('Gwanghwamun' 'Sejong Center for the Performing Arts')
		('Jongno 3(sam)-ga' 'Tapgol ParkInsa-dong')
		('Achasan' 'Rear Entrance to Seoul Children''s Grand Park')
		('Gwangnaru' 'Presbyterian. College & Seminary')
		('Cheonho' 'Pungnaptoseong')
	) do: [:array|
		[:stationName :secondName | instance giveStationNamed: stationName aSecondName:  secondName ] valueWithArguments: array].
	
	^instance! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/22/2009 14:45'!
line5SangilDongBranch

	| instance |
	instance := self line5Prebuild: '5-Sang-il-dong'.

	instance addStationsWithNamesAndCosts:
#('Gil-dong' 2 'Gubeundari' 1 'Myeongil' 2 'Godeok' 3 'Sangil-dong').

	(instance stationAtName: 'Gangdong') connect: (instance stationAtName: 'Gil-dong') cost: 2.
	
	^instance! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 11/12/2009 16:09'!
line6
	
	| instance |
	instance := self new.
	instance lineName: '6'.
	instance lineColor: (Color r:197/255 g:92/255 b:29/255).
	instance idPrefix: ''.
	
	instance setIntegerForFirstStationId: 610.
	#('Eungam' 'Yeokchon' 'Bulgwang' 'Dokbawi' 'Yeonsinnae' 'Gusan')
		do: [ :each | instance addStationNamed: each ].
	instance addStationsWithNamesAndCosts:
#('Saejeol' 2 'Jeungsan' 1 'Digital Media City' 2 'World Cup Stadium' 2 'Mapo-gu Office' 2 'Mangwon' 2 'Hapjeong' 1 'Sangsu'  2 'Gwangheungchang' 2 'Daeheung' 2 'Gongdeok' 2 'Hyochang Park' 2 'Samgakji' 2 'Noksapyeong' 1 'Itaewon' 2 'Hangangjin' 2 'Beotigogae' 2 'Yaksu' 2 'Cheonggu' 1 'Sindang' 2 'Dongmyo' 2 'Changsin' 1 'Bomun' 2 'Anam' 2 'Korea Univ.'  2 'Wolgok' 2 'Sangwolgok' 1 'Dolgoji' 2 'Seokgye' 2 'Taereung' 2 'Hwarangdae' 2 'Bonghwasan').

	instance connectWithDirectionWithStationNamesAndCosts: #('Eungam' 2 'Yeokchon' 2 'Bulgwang' 2 'Dokbawi' 3 'Yeonsinnae' 1 'Gusan').
	
	(instance stationAtName: 'Gusan') connectToTwisted: (instance stationAtName: 'Eungam') cost: 2.
	(instance stationAtName: 'Eungam') connect: (instance stationAtName: 'Saejeol') cost: 2.
	
	#(
		('Hwarangdae'  'Seoul Women''s Univ.')
		('Sangwolgok'  'KIST')
		('Wolgok' 'Dongduk Women''s Univ.')
		('Korea Univ.' 'Jongam')
		('Anam'  'Korea Univ. Hospital')
		('Hyochang Park'  'Yongsan-gu Office')
		('Daeheung'  'Sogang Univ.')
		('Saejeol'  'Sinsa')
		('Jeungsan'   'Myongji Univ.')
		('World Cup Stadium'   'Seongsan') 
		('Gwangheungchang' 'Seogang')
	) do: [:array|
		[:stationName :secondName | instance giveStationNamed: stationName aSecondName:  secondName ] valueWithArguments: array].

	^instance! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/31/2009 14:04'!
line7

	| instance |
	instance := self new.
	instance lineName: '7'.
	instance lineColor: (Color r:84/255g:100/255b:13/255).
	instance idPrefix: ''.
	instance setIntegerForFirstStationId: 709. "?"

	#(	'Jangam' 'Dobongsan' 'Suraksan' 'Madeul' 'Nowon' 'Junggye'
	'Hagye' 'Gongneung' 'Taereung' 'Meokgol' 'Junghwa' 'Sangbong'
	'Myeonmok' 'Sagajeong' 'Yongmasan' 'Junggok' 'Gunja' 'Children''s Grand Park'
	'Konkuk Univ.' 'Ttukseom Resort' 'Cheongdam' 'Gangnam-gu Office' 'Hak-dong'
	'Nonhyeon' 'Banpo' 'Express Bus Terminal' 'Naebang' 'Isu' 'Namseong'
	'Soongsil Univ.' 'Sangdo' 'Jangseungbaegi' 'Sindaebangsamgeori' 'Boramae'
	'Sinpung' 'Daerim' 'Namguro' 'Gasan Digital Complex' 'Cheolsan' 'Gwangmyeongsageori'
	'Cheonwang' 'Onsu'
	)
		do: [:stationName| 
			instance addStationNamed: stationName ].
	instance connectStationsWithEdgesWithTimeSpanMinutes:  #(3 2 2 2 2 2 1 2 2 2 2 2 1 2 2 2 2 2 3 2 1 2 2 2 3 2 2 3 1 2 3 1 2 3 2 1 3 2 3 3 2).
	
	#(
		('Gongneung' 'Seoul National Univ. of Technology')
		('Sangbong' 'Intercity Bus Terminal')
		('Gunja' 'Neung-Dong')
		('Children''s Grand Park' 'Sejong Univ.')
		('Soongsil Univ.'  'Salpijae')
		('Daerim' 'Guro-gu Office')
		('Onsu' 'Sungkonghoe Univ.')
	) do: [:array|
		[:stationName :secondName | instance giveStationNamed: stationName aSecondName:  secondName ] valueWithArguments: array].
	
	^instance! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/31/2009 14:05'!
line8

	| instance |
	instance := self new.
	instance lineName: '8'.
	instance lineColor: (Color r:245/255g:19/255b:97/255).
	instance idPrefix: ''.
	instance setIntegerForFirstStationId: 810.
	
	#('Amsa' 'Cheonho' 'Gangdong-gu Office' 'Mongchontoseong' 'Jamsil' 'Seokchon' 'Songpa' 'Garak Market' 'Munjeong' 'Jangji' 'Bokjeong' 'Sanseong' 'Namhansanseong' 'Dandaegogeori' 'Sinheung' 'Sujin' 'Moran') do: [ :each | 
		instance addStationNamed: each ].
	
	instance connectStationsWithEdgesWithTimeSpanMinutes: #(2 2 3 2 2 2 2 2 2 2 4 3 2 2 2 2).
	
	#(
		('Cheonho' 'Pungnaptoseong')
		('Mongchontoseong' 'World Peace Gate')
		('Jamsil' 'Songpa-gu Office')
		('Namhansanseong' 'Seongnam Court & Public Prosecutor''s Office')
		
	) do: [:array|
		[:stationName :secondName | instance giveStationNamed: stationName aSecondName:  secondName ] valueWithArguments: array].
	
	^instance! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/31/2009 14:06'!
line9

	| fastLine slowLine instance |
	fastLine := self line9Fast.
	slowLine := self line9Slow.
	instance := self new.
	instance lineName: '9'.

	instance stations addAll: fastLine stations.
	instance stations addAll: slowLine stations.

	fastLine stations do: [:station| 
		station connect: (slowLine stationAtName: station name) cost: 13.
		self revisit: 'Are transfer time cost for all stations same?'.
		].

	instance lineColor: (Color r:170/255 g:152/255 b:114/255).
	^instance! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/31/2009 14:05'!
line9Fast
	
	| instance |
	instance := self new.
	instance lineName: '9-fast'.
	instance lineColor: (Color r: 170/255 g:152/255 b:114/255).
	instance addStationsWithNamesAndIds:
	#(
		('Gimpo Int''l Airport' '902')
		('Gayang' '907')
		('Yeomchang' '910')
		('Dangsan'  '913')
		('Yeouido' '915')
		('Noryangjin' '917')
		('Dongjak' '920')
		('Express Bus Terminal' '923')
		('Sinnonhyeon' '925')
	).
	instance connectWithStationNamesAndCosts:
#('Gimpo Int''l Airport' 5 'Gayang' 5 'Yeomchang' 4 'Dangsan' 3 'Yeouido' 2 'Noryangjin' 3
'Dongjak' 4 'Express Bus Terminal' 5 'Sinnonhyeon').
	self revisit: 'Time span is not real data.'.
	"Fast lines are fast but they need to be wait long to get aboard. How to implement that?"
	^instance! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/31/2009 14:05'!
line9Slow

	| instance |
	instance := self new.
	instance lineName: '9-slow'.
	instance lineColor: (Color r: 170/255 g:152/255 b:114/255).
	
	instance setIntegerForFirstStationId: 901.
	instance addStationsWithNamesAndCosts:
 #('Gaehwa' 5 'Gimpo Int''l Airport' 1 'Airport Market' 2 'Sinbanghwa' 2 'Magongnaru' 1 'Yangcheon Hyanggyo' 2 'Gayang' 2 'Jeungmi' 2 'Deungchon' 2 'Yeomchang' 1 'Sinmokdong' 3 'Seonyudo' 2 'Dangsan' 2   'National Assembly' 2 'Yeouido' 2 'Saetgang' 2 'Noryangjin' 2 'Nodeul' 2 'Heukseok' 2 'Dongjak' 2 'Gubanpo' 2 'Sinbanpo' 2 'Express Bus Terminal' 2 'Sapyeong' 1 'Sinnonhyeon').
	instance giveStationsSecondNameWithArrays:
		#(
			('Heukseok' 'Chung-ang Univ.')
			('Dongjak' 'Seoul National Cemetery')
		).

	^instance! !

!JhcLine classSide methodsFor: 'instance creation' stamp: 'hjo 10/31/2009 14:04'!
loadData: input for: lineId
	| instance literalArrays prevStation nextStation accessor |
	
	instance := self new.
	instance lineName: lineId.
	
	literalArrays := input lines collect: [ :each |
			self parseInputLine: each
		].

	accessor := KeyedObjectAccessor new.
	accessor setArrayIndicesAs: #(id stationName timespanToArrive).
	
	"add first station"
	accessor object: literalArrays first.
	instance addStationNamed: accessor stationName id: accessor id.
								
	literalArrays doCouple: [:prevRow :nextRow|
		accessor object: prevRow.
		prevStation := instance stationAtName: accessor stationName.
		accessor object: nextRow.
		nextStation := instance addStationNamed: accessor stationName id: accessor id.
		prevStation connect: nextStation cost: accessor timespanToArrive asNumber.
		].
	
	"if the line is circular one, then connect first and last stations"
	accessor object: literalArrays first.
	(accessor timespanToArrive = '0') ifFalse: [
		instance stations first connect: instance stations last cost: accessor timespanToArrive asNumber].
	^instance! !

!JhcLine classSide methodsFor: 'instance helper' stamp: 'jhan 10/12/2009 00:24'!
parseInputLine: line
	^line subStrings: Character tab asString! !

!JhcLine methodsFor: 'graphs' stamp: 'jhan 10/2/2009 00:50'!
addStationNamed: aByteString 
	^self addStationNamed: aByteString idNumber: self nextIdNumber! !

!JhcLine methodsFor: 'graphs' stamp: 'hjo 10/31/2009 14:08'!
addStationNamed: aByteString id: niceIdString

	^stations add: (JhcStation newName: aByteString line: self id: niceIdString)! !

!JhcLine methodsFor: 'graphs' stamp: 'hjo 10/31/2009 14:08'!
addStationNamed: aByteString idNumber: aSmallInteger 

	^stations add: (JhcStation newName: aByteString line: self id: self idPrefix , aSmallInteger printString)
! !

!JhcLine methodsFor: 'graphs' stamp: 'hjo 10/19/2009 17:38'!
addStationNamed: aByteString secondName: aByteString2 

	| newStation |
	newStation := self addStationNamed: aByteString.
	newStation secondName: aByteString2.
	^newStation! !

!JhcLine methodsFor: 'graphs' stamp: 'hjo 10/19/2009 19:00'!
addStationNamed: aByteString secondName: nilOrString id: aByteString3 

	| newStation |
	newStation := self addStationNamed: aByteString  id: aByteString3.
	newStation secondName: nilOrString.
	^newStation! !

!JhcLine methodsFor: 'graphs' stamp: 'hjo 10/22/2009 14:26'!
addStationsWithNames: nameArray withCosts: costArray 
	
	| stationsAdded |
	stationsAdded := nameArray collect: [ :each | self addStationNamed: each ].
	self class connctStations: stationsAdded withMinuteStream: costArray readStream.
	^stationsAdded! !

!JhcLine methodsFor: 'graphs' stamp: 'hjo 10/21/2009 18:51'!
addStationsWithNamesAndCosts: anArray

	"anArray is a one dimensional array, station names interlaced with costs(timespans in minutes).
	This might increase some code readablity.
	e.g   #('Seoul Station' 2 'City Hall' 3 'Jonggakk' 2 'Jongno 3(sam)-ga')"
	
	[:stationNames :costs| ^self addStationsWithNames: stationNames withCosts: costs ]
		valueWithArguments: (anArray deinterlacedBy: 2)	! !

!JhcLine methodsFor: 'shortcuts' stamp: 'hjo 10/28/2009 19:50'!
addStationsWithNamesAndIds: anArray 

	"anArray has Arrays of data: ( id , stationName )"
	anArray do: [:dataArray | 
		[:sName :idString | self addStationNamed: sName id: idString] valueWithArguments: dataArray
		]! !

!JhcLine methodsFor: 'as yet unclassified' stamp: 'jhan 11/1/2009 21:32'!
asCode
	^ String streamContents: [ :stream | self asCodeOn: stream ].! !

!JhcLine methodsFor: 'as yet unclassified' stamp: 'jhan 11/1/2009 22:13'!
asCodeOn: aStream 
	aStream nextPutAll: self class name;
		nextPutAll: ' new'; cr;
		tab; nextPutAll: 'lineName: ' ; nextPutAll: lineName printString; nextPut: $; ; cr;
		tab; nextPutAll: 'lineColor: ' ; nextPutAll: lineColor printString; nextPut: $; ; cr;
		tab; nextPutAll: 'stations: #('; cr.
	stations do: [:station |
		aStream tab; tab; nextPutAll: (station getAttributes: #(id name secondName)) printString.
		aStream space.
		aStream nextPutAll: (self interval: station) printString.
		aStream cr
		 ].
	aStream tab; nextPutAll: ').'! !

!JhcLine methodsFor: 'connecting stations' stamp: 'hjo 10/10/2009 15:13'!
connectStationsInRange: indicesOfStation withEdgesWithTimeSpanMinutes: minutes 

	self class connctStations: (indicesOfStation collect: [:each| stations at: each]) withMinuteStream: minutes readStream! !

!JhcLine methodsFor: 'connecting stations' stamp: 'hjo 10/10/2009 15:15'!
connectStationsWithEdgesTimeSpan2Minutes

	self class connctStations: stations withMinuteStream: (stations size copiesOf: 2) readStream! !

!JhcLine methodsFor: 'connecting stations' stamp: 'hjo 10/10/2009 15:40'!
connectStationsWithEdgesWithTimeSpanMinutes: anArray 

	self class connctStations: stations withMinuteStream: anArray readStream! !

!JhcLine methodsFor: 'connecting stations' stamp: 'hjo 10/23/2009 17:31'!
connectWithDirectionWithStationNamesAndCosts: anArray 

	"anArray is a one dimensional array, station names interlaced with costs(timespans in minutes).
	This might increase some code readablity.
	e.g   #('Seoul Station' 2 'City Hall' 3 'Jonggakk' 2 'Jongno 3(sam)-ga')"
	
	[ :stationNames :costs |
		self class connctWithDirectionStations:  (stationNames collect: [:each| self stationAtName: each]) withMinuteStream: costs readStream]
		valueWithArguments: (anArray deinterlacedBy: 2)! !

!JhcLine methodsFor: 'connecting stations' stamp: 'hjo 10/21/2009 18:54'!
connectWithStationNamesAndCosts: anArray 

	"anArray is a one dimensional array, station names interlaced with costs(timespans in minutes).
	This might increase some code readablity.
	e.g   #('Seoul Station' 2 'City Hall' 3 'Jonggakk' 2 'Jongno 3(sam)-ga')"
	
	[ :stationNames :costs |
		self class connctStations:  (stationNames collect: [:each| self stationAtName: each]) withMinuteStream: costs readStream]
		valueWithArguments: (anArray deinterlacedBy: 2)
! !

!JhcLine methodsFor: 'shortcuts' stamp: 'hjo 10/20/2009 17:34'!
giveStationNamed: aByteString aSecondName: aByteString2 

	(self stationAtName: aByteString) secondName: aByteString2! !

!JhcLine methodsFor: 'shortcuts' stamp: 'hjo 10/29/2009 03:57'!
giveStationsSecondNameWithArrays: nameAndSecondNamePairs

	"nameAndSecondNamePairs :  #(('Dongjak' 'Seoul National Cemetery') ('Heukseok' 'Chung-ang Univ.'))"
	nameAndSecondNamePairs do: [:array| 
			[ :nameString :secondString | 
				self giveStationNamed: nameString aSecondName: secondString
			] valueWithArguments: array
		]! !

!JhcLine methodsFor: 'accessing' stamp: 'jhan 10/19/2009 21:59'!
idPrefix
	^ idPrefix ifNil: [ idPrefix := '' ]! !

!JhcLine methodsFor: 'accessing' stamp: 'hjo 9/27/2009 21:58'!
idPrefix: aByteString 

	idPrefix := aByteString ! !

!JhcLine methodsFor: 'initialize-release' stamp: 'hjo 9/27/2009 22:00'!
initialize

	super initialize.
	stations := OrderedCollection new! !

!JhcLine methodsFor: 'accessing' stamp: 'jhan 10/2/2009 00:33'!
integerStream
	integerStream isNil ifTrue: [ integerStream := IntegerStream new ].
	^integerStream! !

!JhcLine methodsFor: 'as yet unclassified' stamp: 'hjo 11/7/2009 00:54'!
interval: aStation 
	(aStation = stations first) ifTrue: [ ^0 ].
	stations do: [:each| each clearMinimumCostPaths].
	^(stations before: aStation) timespanMinutesTo: aStation! !

!JhcLine methodsFor: 'accessing' stamp: 'hjo 10/13/2009 13:49'!
lineColor

	^lineColor! !

!JhcLine methodsFor: 'accessing' stamp: 'hjo 10/13/2009 13:55'!
lineColor: aColor 

	lineColor := aColor! !

!JhcLine methodsFor: 'accessing' stamp: 'hjo 10/31/2009 13:59'!
lineName

	^lineName! !

!JhcLine methodsFor: 'accessing' stamp: 'hjo 10/31/2009 14:00'!
lineName: aByteString 

	lineName :=  aByteString ! !

!JhcLine methodsFor: 'query' stamp: 'jhan 10/2/2009 00:48'!
neighbors
	self shouldBeImplemented! !

!JhcLine methodsFor: 'accessing' stamp: 'jhan 10/2/2009 00:32'!
nextIdNumber
	^self integerStream next! !

!JhcLine methodsFor: 'printing' stamp: 'jhan 11/1/2009 16:04'!
printOn: aStream

	aStream nextPutAll: 'Line('.
	aStream nextPutAll: lineName printString.
	aStream nextPutAll: ')'.
! !

!JhcLine methodsFor: 'accessing' stamp: 'hjo 10/7/2009 21:02'!
setIntegerForFirstStationId: aSmallInteger 

	self integerStream current: aSmallInteger! !

!JhcLine methodsFor: 'query' stamp: 'jhan 10/13/2009 10:26'!
stationAtId: aByteString 

	| subStations |
	subStations := self stations select: [:each| each id = aByteString ].
	(subStations size = 1) ifTrue: [ ^subStations first ]
								ifFalse: [ ^JhcTransferStation with: subStations ]! !

!JhcLine methodsFor: 'query' stamp: 'hjo 10/20/2009 18:54'!
stationAtName: aByteString 

	| subStations |
	subStations := self stations select: [:each| each name = aByteString ].
	self assert: [subStations isEmpty not] description: 'There is no station named like that.'.
	(subStations size = 1) ifTrue: [ ^subStations first ]
								ifFalse: [ ^JhcTransferStation with: subStations ]! !

!JhcLine methodsFor: 'query' stamp: 'hjo 10/31/2009 14:03'!
stationAtName: aByteString lineName: aByteString2 

	| arrayOfOneStation |
	arrayOfOneStation := (self  stations select: [:each| each name = aByteString]) select: [:each| each lineName = aByteString2].
	self assert: [arrayOfOneStation size = 1] description: 'There is only one station that of name and line id combination.'.
	^arrayOfOneStation anyOne! !

!JhcLine methodsFor: 'accessing' stamp: 'hjo 9/27/2009 22:27'!
stations

	^stations! !

Object subclass: #JhcPlatform
	instanceVariableNames: 'line graphVertex station'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcPlatform methodsFor: 'as yet unclassified' stamp: 'hjo 11/6/2009 20:01'!
clearMinimumCostPaths

	graphVertex clearMinimumCostPaths! !

!JhcPlatform methodsFor: 'printing' stamp: 'hjo 11/9/2009 14:49'!
descriptionByStation

	^station descriptionForPlatform: self! !

!JhcPlatform methodsFor: 'printing' stamp: 'hjo 11/9/2009 14:48'!
graphPathSymbolText

	^self descriptionByStation ,  ' of ' , (line isNil ifTrue: ['nil line'] ifFalse: [line lineName])! !

!JhcPlatform methodsFor: 'accessing' stamp: 'hjo 11/6/2009 18:25'!
graphVertex

	^graphVertex! !

!JhcPlatform methodsFor: 'initialize-release' stamp: 'hjo 11/6/2009 18:24'!
initialize

	super initialize.
	graphVertex := CostVertex new.
	graphVertex masterObject: self! !

!JhcPlatform methodsFor: 'accessing' stamp: 'hjo 11/6/2009 19:49'!
line: aJhcLine 

	line := aJhcLine! !

!JhcPlatform methodsFor: 'printing' stamp: 'hjo 11/9/2009 14:44'!
printVertexDescriptionForGraphPathOn: aWriteStream 

	self printVertexDetailOn: aWriteStream ! !

!JhcPlatform methodsFor: 'printing' stamp: 'hjo 11/9/2009 17:56'!
printVertexDetailOn: aWriteStream 

	aWriteStream nextPutAll: self graphPathSymbolText
	
	! !

!JhcPlatform methodsFor: 'accessing' stamp: 'hjo 11/7/2009 00:44'!
station

	^station! !

!JhcPlatform methodsFor: 'accessing' stamp: 'hjo 11/7/2009 00:44'!
station: aJhcStation

	station := aJhcStation! !

Object subclass: #JhcSegment
	instanceVariableNames: 'timespanMinutes graphEdge'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcSegment classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 13:15'!
newTimespanMinutes: aNumber

	^self new
		timespanMinutes: aNumber 

	! !

!JhcSegment methodsFor: 'as yet unclassified' stamp: 'hjo 9/19/2009 18:52'!
graphEdge

	^graphEdge! !

!JhcSegment methodsFor: 'as yet unclassified' stamp: 'hjo 10/10/2009 10:02'!
initialize

	super initialize.
	graphEdge := CostEdge new.
	graphEdge masterObject: self! !

!JhcSegment methodsFor: 'as yet unclassified' stamp: 'hjo 9/18/2009 13:22'!
timespanMinutes

	^timespanMinutes! !

!JhcSegment methodsFor: 'as yet unclassified' stamp: 'hjo 9/26/2009 19:36'!
timespanMinutes: aNumber

	self revisit: 'duplicate information!!'.
	timespanMinutes := aNumber.
	graphEdge cost: aNumber! !

Object subclass: #JhcStation
	instanceVariableNames: 'name id line secondName screenPosition platform1 platform2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcStation classSide methodsFor: 'as yet unclassified' stamp: 'jhan 10/2/2009 01:03'!
defaultCost
	^2! !

!JhcStation classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/17/2009 18:05'!
newName: aByteString line: aSmallInteger id: aSmallInteger3 

	^self new
		name: aByteString;
		line: aSmallInteger;
		id: aSmallInteger3! !

!JhcStation classSide methodsFor: 'as yet unclassified' stamp: 'hjo 10/19/2009 17:06'!
newName: aByteString secondName: aByteString2 line: aByteString3 id: aByteString4 

	^self new
		name: aByteString;
		line: aByteString3;
		id: aByteString4;
		secondName: aByteString2! !

!JhcStation methodsFor: 'as yet unclassified' stamp: 'hjo 11/6/2009 19:59'!
clearMinimumCostPaths

	self platform1 clearMinimumCostPaths.
	self platform2 clearMinimumCostPaths.! !

!JhcStation methodsFor: 'graphs' stamp: 'jhan 10/2/2009 01:03'!
connect: aJhcStation 
	self connect: aJhcStation cost: self class defaultCost! !

!JhcStation methodsFor: 'graphs' stamp: 'hjo 11/9/2009 13:10'!
connect: other cost: c 

	self platform1 graphVertex connectTo: other platform1 graphVertex cost: c.
	other platform2 graphVertex connectTo: self platform2 graphVertex cost: c! !

!JhcStation methodsFor: 'graphs' stamp: 'hjo 11/9/2009 22:48'!
connectSplittingStation: stationOfOtherLine cost: c 

	self platform1 graphVertex connect: stationOfOtherLine platform1 graphVertex cost: c.
	self platform1 graphVertex connect: stationOfOtherLine platform2 graphVertex cost: c.
	self platform2 graphVertex connect: stationOfOtherLine platform1 graphVertex cost: c.
	self platform2 graphVertex connect: stationOfOtherLine platform2 graphVertex cost: c! !

!JhcStation methodsFor: 'graphs' stamp: 'hjo 11/12/2009 09:59'!
connectTo: otherStation cost: aNumber

	self platform1 graphVertex connectTo: otherStation platform1 graphVertex cost: aNumber! !

!JhcStation methodsFor: 'graphs' stamp: 'hjo 11/12/2009 16:10'!
connectToTwisted: otherStation cost: aNumber 

	self platform1 graphVertex connectTo: otherStation platform2 graphVertex cost: aNumber! !

!JhcStation methodsFor: 'defaults' stamp: 'hjo 11/7/2009 00:45'!
defaultPlatform

	| p |
	p := JhcPlatform new.
	p line: line.
	p station: self.
	^p
	! !

!JhcStation methodsFor: 'printing' stamp: 'hjo 11/9/2009 16:16'!
descriptionForPlatform: aJhcPlatform 

	| what |
	what := 'stationless platform'.
	aJhcPlatform == platform1 ifTrue: [what := 'platform1'].
	aJhcPlatform == platform2 ifTrue: [what := 'platform2'].
	^what , ' of ' , self name
! !

!JhcStation methodsFor: 'printing' stamp: 'hjo 10/8/2009 16:16'!
detailPrintStringForVertex

	^name! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 11/9/2009 14:27'!
graphVertices
	
	^self platforms collect: [:each| each graphVertex ]! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/27/2009 22:31'!
id

	^id! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/17/2009 18:04'!
id: aSmallInteger 

	id := aSmallInteger! !

!JhcStation methodsFor: 'initialize-release' stamp: 'hjo 11/9/2009 14:14'!
initialize

	super initialize.
	self platform1 graphVertex connect: self platform2 graphVertex cost: 4! !

!JhcStation methodsFor: 'testing' stamp: 'hjo 10/20/2009 09:42'!
isPositiveToFilterLowercaseQuery: lowercasedFilterQuery

	"Not sensitive to case."
	lowercasedFilterQuery isNil ifTrue: [ ^true].
	^(self name asLowercase indexOfSubCollection: lowercasedFilterQuery) > 0! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/18/2009 13:47'!
line

	^line! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 10/31/2009 16:40'!
line: aJhcLine 

	line := aJhcLine! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 10/31/2009 14:08'!
lineName
	^line lineName! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 10/31/2009 14:52'!
lineNames

	^Array with: line lineName! !

!JhcStation methodsFor: 'accessing' stamp: 'jhan 10/12/2009 23:23'!
lines

	^{line}! !

!JhcStation methodsFor: 'querying' stamp: 'hjo 11/9/2009 18:23'!
minimumTimeCostPathClubsFrom: aJhcStation 

	^((Array with: self graphVertices with:aJhcStation graphVertices) multiDimensionalCollect2:[:a :b|a minCostPathClubFrom: b])
		select: [:each| each minimum isNumber]! !

!JhcStation methodsFor: 'querying' stamp: 'hjo 11/9/2009 18:23'!
minimumTimeCostPathsFrom: aJhcStation 

	| clubs metaClub |
	clubs := self minimumTimeCostPathClubsFrom: aJhcStation.
	metaClub := MinClub new.
	metaClub evaluator: [:each| each minimum ].
	metaClub putAll: clubs.
	^(metaClub members collect: [:each| each members]) concatenateAll! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/17/2009 18:01'!
name

	^name! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 9/17/2009 18:04'!
name: aByteString 
	name := aByteString! !

!JhcStation methodsFor: 'querying' stamp: 'hjo 11/9/2009 01:41'!
neighbors

	| myVertices neighboringVertices |
	myVertices := self platforms collect: [:each| each graphVertex ].
	neighboringVertices := (myVertices collect: [:each| each neighbors asArray ]) concatenateAll.
	^((neighboringVertices copyWithoutAll: myVertices) collect: [:each | each masterObject station]) asSet! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 11/6/2009 19:57'!
platform1

	^platform1 setDefault: #defaultPlatform for: self withSetter: #platform1:! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 11/6/2009 19:50'!
platform1: aJhcPlatform 

	platform1 := aJhcPlatform ! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 11/6/2009 19:55'!
platform2

	^platform2 setDefault: #defaultPlatform for: self withSetter: #platform2:! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 11/6/2009 19:56'!
platform2: aJhcPlatform 
	
	platform2 :=aJhcPlatform! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 11/7/2009 00:51'!
platforms

	^Array with: self platform1 with: self platform2! !

!JhcStation methodsFor: 'printing' stamp: 'jhan 11/1/2009 17:05'!
printOn: aStream
	aStream nextPutAll: 'Station('.
	aStream nextPutAll: name.
	aStream nextPutAll: ')'! !

!JhcStation methodsFor: 'printing' stamp: 'hjo 9/28/2009 12:38'!
printVertexDetailOn: aStream

	aStream print: name! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 10/31/2009 18:19'!
screenPosition
	
	^screenPosition! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 10/31/2009 18:16'!
screenPosition: aPoint 

	screenPosition := aPoint! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 10/19/2009 16:56'!
secondName

	"Most stations does not have a second name. But some stations have second name scripted inside of parenthesis.
	e.g.)   Jamsil (Songpa-gu Office) 
	Songpa-gu Office is the second name for Jamsil station."
	^secondName! !

!JhcStation methodsFor: 'accessing' stamp: 'hjo 10/19/2009 16:57'!
secondName: aString

	"Most stations does not have a second name. But some stations have second name scripted inside of parenthesis.
	e.g.)   Jamsil (Songpa-gu Office) 
	Songpa-gu Office is the second name for Jamsil station."
	secondName := aString! !

!JhcStation methodsFor: 'querying' stamp: 'hjo 11/9/2009 18:30'!
timespanMinutesFromSingleStation: aJhcStation 

	^(((Array with: self graphVertices with:aJhcStation graphVertices) multiDimensionalCollect2:[:a :b|a minimumCostFrom: b]) select: [:each| each isNumber]) min! !

!JhcStation methodsFor: 'querying' stamp: 'jhan 10/13/2009 00:33'!
timespanMinutesTo: aJhcStation 

	^aJhcStation timespanMinutesFromSingleStation: self.! !

Object subclass: #JhcSubway
	instanceVariableNames: 'lines filteredStations filterQuery nearTouchRadius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcSubway commentStamp: 'hjo 10/31/2009 18:48' prior: 0!
I can be a single object of Jihachol application, unless its coverage is extended to internation subways. My top responsibility is to contain lines with stations. My secondary reponsibility is to answer stations with various ways of querying. I don't know anything how the answered station will be used by the client.!

!JhcSubway methodsFor: 'as yet unclassified' stamp: 'jhan 11/1/2009 15:43'!
buildAllLines

	^ #(bundang line1 line2 line3 line4 line5 line6 line7 line8 line9)
			collect: [:instantiationMethod| JhcLine perform: instantiationMethod ]! !

!JhcSubway methodsFor: 'as yet unclassified' stamp: 'hjo 10/19/2009 19:38'!
filterBy: aByteString 

	filterQuery = aByteString
		ifFalse: [ 
			filterQuery := aByteString.
			filteredStations := nil
			]! !

!JhcSubway methodsFor: 'as yet unclassified' stamp: 'hjo 10/20/2009 09:44'!
filteredStations
	
	| lowercaseQuery |
	filterQuery isNil ifTrue: [ filteredStations := self stations copy. ^filteredStations ].
	lowercaseQuery := filterQuery asLowercase.
	filteredStations isNil ifTrue: [ filteredStations := self stations select: [:each| each isPositiveToFilterLowercaseQuery: lowercaseQuery ] ].
	^filteredStations! !

!JhcSubway methodsFor: 'as yet unclassified' stamp: 'hjo 10/19/2009 19:24'!
initialize

	super initialize.
	lines := self buildAllLines! !

!JhcSubway methodsFor: 'accessing' stamp: 'hjo 10/31/2009 18:24'!
lines: anArray 

	lines := anArray! !

!JhcSubway methodsFor: 'testing' stamp: 'hjo 10/31/2009 18:19'!
nearStationAt: aPoint 

	^self stations select: [:each| (each screenPosition - aPoint) r <= nearTouchRadius]! !

!JhcSubway methodsFor: 'as yet unclassified' stamp: 'hjo 10/31/2009 18:17'!
nearTouchRadius: aNumber

	nearTouchRadius := aNumber! !

!JhcSubway methodsFor: 'as yet unclassified' stamp: 'hjo 10/19/2009 19:28'!
stations

	^Array streamContents: [:stream| 
		lines do: [:each|  stream nextPutAll: each stations ]
		]! !

Object subclass: #JhcTransferStation
	instanceVariableNames: 'subStations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcTransferStation commentStamp: 'jhan 10/13/2009 10:25' prior: 0!
I am a station where people can transfer between lines. I have several sub stations. Each sub station represents a station dedicated a single line. For example, line2 and line2-seongsu-branch has its own 'Seongsu' station. Two seongsu station forms a Transfer station of 'Seongsu'. I forwards the name and id to the first of my sub stations.
I don't have a dedicated graphVertex because I have several of them. So I sometimes behave like a composite node in Composite pattern. If you find a station using name or id, JhcLine creates me in case there're two ore more stations have the same name.!

!JhcTransferStation classSide methodsFor: 'as yet unclassified' stamp: 'jhan 10/12/2009 23:34'!
with: subStations 
	^self new
		subStations: subStations
	! !

!JhcTransferStation methodsFor: 'as yet unclassified' stamp: 'jhan 10/13/2009 10:07'!
id
	^subStations first id.! !

!JhcTransferStation methodsFor: 'accessing' stamp: 'hjo 10/31/2009 14:48'!
lineNames

	^ subStations collect: [:eachSubStation| eachSubStation lineName ]! !

!JhcTransferStation methodsFor: 'as yet unclassified' stamp: 'hjo 10/31/2009 14:48'!
lines
	self halt. "use lineNames"
	^ subStations collect: [:eachSubStation| eachSubStation line]! !

!JhcTransferStation methodsFor: 'as yet unclassified' stamp: 'jhan 10/13/2009 10:06'!
name
	^subStations first name! !

!JhcTransferStation methodsFor: 'accessing' stamp: 'hjo 10/29/2009 04:23'!
secondName

	| secondNames nameSet |
	secondNames := subStations collect: [:each| each secondName].
	(secondNames allSatisfy: [:each| each isNil ]) ifTrue: [^nil].
	nameSet := secondNames asSet.
	self assert: [ nameSet size = 1 ] description: 'Substations have same name'.
	^nameSet anyOne! !

!JhcTransferStation methodsFor: 'as yet unclassified' stamp: 'jhan 10/12/2009 23:36'!
subStations
	(subStations isNil) ifTrue: [subStations := OrderedCollection new].
	^subStations! !

!JhcTransferStation methodsFor: 'as yet unclassified' stamp: 'jhan 10/12/2009 23:35'!
subStations: anOrderedCollection 
	self subStations addAll: anOrderedCollection! !

!JhcTransferStation methodsFor: 'as yet unclassified' stamp: 'jhan 10/13/2009 00:36'!
timespanMinutesFromSingleStation: srcStation
	| timespans |
	timespans := subStations collect: 
		[:eachSubStation| eachSubStation timespanMinutesFromSingleStation: srcStation].
	^timespans min! !

!JhcTransferStation methodsFor: 'as yet unclassified' stamp: 'jhan 10/13/2009 00:19'!
timespanMinutesTo: destStation
	| timespans |
	timespans := subStations collect: 
		[:eachSubStation| eachSubStation timespanMinutesTo: destStation].
	^timespans min! !

Object subclass: #JhcUserInterface
	instanceVariableNames: 'subway startingStation finishingStation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol'!

!JhcUserInterface commentStamp: 'hjo 10/31/2009 18:50' prior: 0!
I am the main object of Jihachol project. Users will not talk to any other object but me.!

Object subclass: #KeyedObjectAccessor
	instanceVariableNames: 'keyMap keyedObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jihachol-Helpers'!

!KeyedObjectAccessor methodsFor: 'error handling' stamp: 'hjo 10/12/2009 17:41'!
doesNotUnderstand: aMessage 

	"WARNING: There is potential bug. If the developer setKey:as: which I can understand, I will not work properly."
	^keyedObject perform: #at: with: (keyMap at: aMessage selector)! !

!KeyedObjectAccessor methodsFor: 'initialize-release' stamp: 'hjo 10/12/2009 17:38'!
initialize

	super initialize.
	keyMap := Dictionary new
	! !

!KeyedObjectAccessor methodsFor: 'accessing' stamp: 'hjo 10/12/2009 17:36'!
object: anObject

	keyedObject := anObject! !

!KeyedObjectAccessor methodsFor: 'accessing' stamp: 'hjo 10/12/2009 17:46'!
setArrayIndicesAs: arrayOfSelectors

	arrayOfSelectors keysAndValuesDo: [:index :selector| 
		self setKey: index as: selector
		]! !

!KeyedObjectAccessor methodsFor: 'accessing' stamp: 'hjo 10/12/2009 17:39'!
setKey: key as: accessorSelector

	keyMap at: accessorSelector put: key

	! !
